/**
 * Starts the app and injects the views
 */
define(['jquery', 'underscore', 'backbone', 'pamhelper','router', 'fastClick', 'sessionManager', 'config', 'localization', 'missionManager', 'views/acceptationPlanning', 'views/auth', 'views/propositions', 'views/enCours', 'views/enCoursSynthese', 'views/enCoursDetails', 'views/contact', 'views/propositionDetails', 'views/propositionRefus/propositionRefus', 'views/propositionRefus/propositionRefusMessages', 'views/planning', 'views/enCoursImprevu', 'views/indisponibilites', 'views/customPwd', 'views/secretQuestion', 'views/checkUserEmail', 'views/changePassword', 'views/changeEmail'], 
	function ($, _, Backbone, pamHelper, Router, fastClick, sessionManager, configuration, locale, missionManager, acceptationPlanningView, authView, propositionsView, enCoursView, enCoursSyntheseView, enCoursDetailsView, contactView, propositionDetailsView, propositionRefusView, propositionRefusMessagesView, planningView, enCoursImprevuView, indisponibilitesView, customPwdView, secretQuestionView, checkUserEmailView, changePasswordView, changeEmailView) {
	// Using ECMAScript 5 strict mode during development. By default r.js will ignore that.
	"use strict";

	var MyApp = MyApp || {
		Views : {
		    auth: authView,
		    customPwd: customPwdView,
			propositions : propositionsView,
			enCours : enCoursView,
			contact : contactView,
			propositionDetails : propositionDetailsView,
			propositionRefus : propositionRefusView,
			propositionRefusMessages : propositionRefusMessagesView,
			changePassword : changePasswordView,
			changeEmail: changeEmailView,
			enCoursSynthese : enCoursSyntheseView,
			enCoursDetails : enCoursDetailsView,
			enCoursImprevu : enCoursImprevuView,
			planning : planningView,
			acceptationPlanning : acceptationPlanningView,
			indisponibilites: indisponibilitesView,
			secretQuestion: secretQuestionView,
            checkUserEmail : checkUserEmailView
		},
		Models : {
			
		},
		defaults : {

		},
		Router : {},
		initialize : function() {
			$(document).ready(function() {
				console.log('App initialization...');
				if (sessionManager)
					MyApp.oSessionManager = new sessionManager(); 
				if (configuration) 
				{
					MyApp.oConfig = new configuration();

					var marque = MyApp.oConfig.marque().toLowerCase();
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/Swipe.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/CommonStyles.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/Auth.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/Contact.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/EnCoursDetails.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/EnCoursSynthese.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/Indisponibilites.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/MissionsEnCours.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/Planning.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/Proposition.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/PropositionDetails.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/"+marque+"/PropositionRefus.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/" + marque + "/custom.css\"/>");
					$("head").append("<link rel=\"stylesheet\" href=\"css/" + marque + "/SecretQuestion.css\"/>");
					
					$("head").append("<link rel=\"apple-touch-icon-precomposed\" href=\"images/"+marque+"/ic_launcher.png\"/>");
					$("head").append("<link rel=\"apple-touch-startup-image\" href=\"images/"+marque+"/ic_launcher.png\"/>");
					$("head").append("<link rel=\"shortcut icon\" href=\"images/"+marque+"/ic_launcher.png\"/>");
					$("head").append("<link rel=\"icon\" href=\"images/"+marque+"/ic_launcher.png\"/>");

				}

				if (locale)
					MyApp.oLocale =  locale;
				if (missionManager)
					MyApp.oMissionManager =  new missionManager();
				MyApp.Router = new Router(MyApp);
				MyApp.events(); //register event handler
				Backbone.history.start();
				console.log('App initialized');
			});
		}, 
		events : function (){
			$(document).delegate("#home-page", "pageinit", function() {
				console.log("Pageinit fired for #home-page");
			});
			document.addEventListener('deviceready', MyApp.onDeviceReady, true);
			document.addEventListener("resume", MyApp.authentificationSilencieuse, false);
		},
		onDeviceReady : function (){

			console.log(MyApp.oConfig.deviceToken);
			
			if(PushNotification) {
				var push = PushNotification.init(MyApp.oConfig.pushConfig());

				push.on('registration', function(data) {
					console.log("registration event");
                	MyApp.oSessionManager.setDeviceToken(data.registrationId);
                });

				push.on('notification',function(data) {
					console.log("notification event");
					var regId = data.registrationId;

					console.log("send push token : " + regId);

					// Update the value in config if FirstLaunch
					MyApp.oConfig.firstLaunch = data.additionalData.coldstart;

					if (regId && regId != "") {
						MyApp.oSessionManager.setDeviceToken(regId);
						pamHelper.sendRestRequest({
							url: 'authpam/Authentification/Auth',
							type:'POST',
							data: JSON.stringify({DeviceID: regId, VersionAppli: MyApp.oConfig.appVersion(), DeviceName: MyApp.oConfig.deviceName(),CodeMarque: MyApp.oConfig.marque(),DeviceFamily :MyApp.oConfig.deviceFamily()})
						});
					}

				});

				push.on('error', function(e) {
					console.log("push error : " + JSON.stringify(e));
				});
			}
       
        },
        authentificationSilencieuse : function (){

        	if(MyApp.oSessionManager.getToken() && MyApp.oSessionManager.getToken()!= "") {
				pamHelper.sendRestRequest({
					url: 'authpam/Authentification/Auth',
					type:'POST',
					data: JSON.stringify({DeviceID: MyApp.oSessionManager.getDeviceToken(), DeviceName: MyApp.oConfig.deviceName(), VersionAppli: MyApp.oConfig.appVersion() ,CodeMarque: MyApp.oConfig.marque(), DeviceFamily: MyApp.oConfig.deviceFamily()})
				});
			}	
		}
	};

	// make app global
	window.MyApp = MyApp;
	return MyApp;
});
