define([], function(){
	var dateHelper = function(){
		this.formatDate = function (d) {
			  var dd = d.getDate();
			  if ( dd < 10 ) 
				  dd = '0' + dd;
			  var mm = d.getMonth()+1;
			  if ( mm < 10 ) 
				  mm = '0' + mm;
			  var yy = d.getFullYear() % 100;
			  if ( yy < 10 ) 
				  yy = '0' + yy;
			  return dd+'/'+mm+'/'+yy;
			}
		this.parseDate= function (input) {
			  var parts = input.match(/(\d+)/g);
			  return new Date(parts[0], parts[1]-1, parts[2]);
			}
		this.formatDateFullYear = function (d) {
			  var dd = d.getDate();
			  if ( dd < 10 ) 
				  dd = '0' + dd;
			  var mm = d.getMonth()+1;
			  if ( mm < 10 ) 
				  mm = '0' + mm;
			  var yy = d.getFullYear();
			  return dd+'/'+mm+'/'+yy;
			}
		this.parseDateFullYear = function(dateInuput){
			var dateParts = dateInuput.split('/');
			var day = parseInt(dateParts[0].replace(/^0/,''));
			var month = parseInt(dateParts[1].replace(/^0/,''));
			var year = parseInt(dateParts[2]);
			return new Date(year, month - 1, day, 0, 0, 0, 0);
		}
		this.isValidDate = function(d)
		{
			if ( Object.prototype.toString.call(d) === "[object Date]" ) {
				  // it is a date
				  if ( isNaN( d.getTime() ) ) {  // d.valueOf() could also work
					  return false;				  
					  }
				  else {
					  return true;
				  }
				}
				else {
					return false;
				}
			return true;
		}
		//Removes the offset of the date due to timezone
		this.getDateWithRemovedOffset = function(dateInput){
			var toReturn = new Date(dateInput.getTime());
			toReturn.setUTCFullYear(dateInput.getFullYear());
			toReturn.setUTCMonth(dateInput.getMonth());
			toReturn.setUTCDate(dateInput.getDate());
			return toReturn;
		}
		this.getDateForUrlPassing = function(dateString){
			//// La date passée dans l'url de l'encre est en dd/mm/yyyy, les '/' ne passent pas dans l'url, on les remplacent par des dates
			//// Méthode appelée lors du refus d'une mission pour cause d'indisponibilité (la date de début de mission est alors passée à l'écran
			//// des indisponibilités pour pré-remplissage du formulaire 
			return dateString.replace(/\//g, '-');
		}
		this.getDateForDisponibiliteFilling = function(dateString){
			//// On reformate la date avec les '/' perdu lors du passage de la date début dans l'url (remplacée par des '-').
			return dateString.replace(/-/g, '/');
		}
	};
	return dateHelper;
})