/**
 *
 */
define(['jquery', 'underscore'], function($, _) {

	var popError = function(message) {
		MyApp.openPopup("#dialog",message);
	};

	var redirectOnLogout = function(){
		if(MyApp.oSessionManager.getAutoLogin()== true){
			// Les identifiants m�moris�s ne sont pas supprim�s
			// Pour pr�-remplir le formulaire d'authentification.
			var login = MyApp.oSessionManager.getLogin();
			var passwd = MyApp.oSessionManager.getPassword();
			// On remet les identifiants dans le cache.
			MyApp.oSessionManager.setLogin(login);
			MyApp.oSessionManager.setPassword(passwd);
		}
		else{
			MyApp.oSessionManager.setLogin('');
			MyApp.oSessionManager.setPassword('');
		}
		// Nettoyage du cache
		MyApp.oSessionManager.setAutoLogin('false');
		MyApp.oSessionManager.setSessionToken('false');
		// On vide le cache
		MyApp.oSessionManager.truncate();
		MyApp.oMissionManager.disconnect();

		// Redirection vers la page d'authentification
		window.location.hash ="#auth/"+MyApp.oLocale.common.error.authentificationError;
	};



	return {

		showNbUnreadMissionsBadge : function(viewElement,missions) {

			var paintUnreadMissionsBadge = function(viewElement,unreadMissions) {
				var eltCountPropositions = $(viewElement).find('#countPropositions');
				if(eltCountPropositions){
					if(unreadMissions.length > 0){
						eltCountPropositions.attr('data-content',unreadMissions.length);
						eltCountPropositions.addClass('count');
					} else {
						eltCountPropositions.removeAttr('data-content');
						eltCountPropositions.removeClass('count');
					}
				}
			};

			if(missions){
				paintUnreadMissionsBadge(viewElement, missions);
			} else {
				MyApp.oMissionManager.getMissions(function(missions){
					paintUnreadMissionsBadge(viewElement, missions.GetCurrentUnreadOffersTag());
				});
			}
		},
		assign : function(container, selector, view) {

			var selectors;

			if (_.isObject(selector)) {
				selectors = selector;
			} else {
				selectors = {};
				selectors[selector] = view;
			}

			if (!selectors)
				return;

			_.each(selectors, function(view, selector) {
				view.setElement(container.$(selector)).render();
			}, container);
		},

		sendRestRequest : function(ajaxObject) {

			$.mobile.showPageLoadingMsg('b', 'Chargement...');

			$.ajax({
				url:  MyApp.oConfig.serverAddress()+'/' + ajaxObject.url,
				dataType: ajaxObject.dataType || 'json',
				type: ajaxObject.type || 'GET',
				contentType: ajaxObject.contentType || 'application/json',
				headers: ajaxObject.headers || {
				    token: MyApp.oSessionManager.getToken(),
				    version: MyApp.oConfig.appVersion(),
				    ApplicationName: MyApp.oSessionManager.getApplicationName()
				},
				data: ajaxObject.data,
				success: function (data) {
					$.mobile.hidePageLoadingMsg();
					if(ajaxObject.success){
						ajaxObject.success(data);
					}

				},
				error : function (data) {
					$.mobile.hidePageLoadingMsg();

					var errorMessage = undefined;
	                if (data && data.responseText) {

	                    try{ //Tentative de désérialisation de la réponse
		                    errorMessage = JSON.parse(data.responseText);
		                } catch(exception) {
		                	popError(MyApp.oLocale.common.error.serverError);
		                }

	                    if(errorMessage) { //Retour serveur lisible
	                    	if(errorMessage.Message){
	                    		try { //Tentative de désérialisation de la réponse
					            	errorMessage = JSON.parse(errorMessage.Message);
					            } catch(exception) {
					            	popError(MyApp.oLocale.common.error.serverError);
					            }
	                    	}
	                    	if(errorMessage) {
		                    	if(errorMessage.CodeErreur == 1) { //L'utilisateur n'est plus identifié, rediction sur la page d'authentification
									redirectOnLogout();
								} else if(errorMessage.CodeErreur == 2) { //Service momentanément indisponible
									popError(MyApp.oLocale.common.error.unavailableError);
								}
								else{ //Erreurs spécifiques au service
									if(ajaxObject.error) { //Le comportement a été défini spécifiquement lors de l'appel
										ajaxObject.error(data, errorMessage);
									} else { //Comportement générique
										popError(errorMessage.LibelleErreur);
									}
								}
							} else { //Retour serveur non lisible, simplification utilisateur : erreur de synchro serveur
								popError(MyApp.oLocale.common.error.serverError);
							}

						} else { //Retour serveur non lisible, simplification utilisateur : erreur de synchro serveur
							popError(MyApp.oLocale.common.error.serverError);
						}
					}
					else { 	//Retour serveur non lisible, simplification utilisateur : erreur de synchro serveur
						popError(MyApp.oLocale.common.error.serverError);
					}
				}
			});
		},

		logout : function(){
			redirectOnLogout();
		}


	};
});
