/**
 * Initialise requirejs with required libraries
 */
requirejs.config({
	//By default load any module IDs from js/lib
	baseUrl : 'js/',

	//except, if the module ID starts with "app",
	//load it from the js/app directory. paths
	//config is relative to the baseUrl, and
	//never includes a ".js" extension since
	//the paths config could be for a directory.
	paths : {
		jquery : 'libs/jquery/jquery-1.8.2.min',
		underscore : 'libs/loDash/lodash.underscore.min',
		backbone : 'libs/backbone/backbone-min',
		jquerymobile : 'libs/jquery-mobile/jquery.mobile-1.3.1',
		sessionManager : 'session/sessionManager',
		config : 'config/config',
		localization : 'locale/locale_fr',
		dateHelper : 'config/DateHelper',
		missionManager: 'connector/MissionConnector',
		generic: 'views/generic',
		fastClick: 'libs/fastclick/fastclick',
		dotdotdot: 'libs/jquery/jquery.dotdotdot-1.5.6',
		md5: 'libs/jquery/jquery-md5',
		swipejs: 'libs/swipejs/swipe',
		moment: 'libs/momentjs/moment',
		app : 'app',
		textFormatHelper : 'config/TextFormatHelper',
		mobiscroll : 'libs/mobiscroll/mobiscroll.core',
		mobiscrollDateTime : 'libs/mobiscroll/mobiscroll.datetime',
		mobiscrollDateTimeFr : 'libs/mobiscroll/mobiscroll.i18n.fr',
		pamhelper:'helper'
	},
	shim : {
		'backbone' : {
			//These script dependencies should be loaded before loading
			//backbone.js
			deps : ['underscore', 'jquery'],
			//Once loaded, use the global 'Backbone' as the
			//module value.
			exports : 'Backbone'
		},
		'pamhelper':{
			deps:['underscore','jquery']
		},
		'jquerymobile' : {
			deps : ['jquery', 'mobiscrollDateTimeFr']
		},
		'dotdotdot' : {
			deps : ['jquery']
		},
		'mobiscroll' : {
			deps : ['jquery']
		},
		'mobiscrollDateTime' : {
			deps : ['mobiscroll']
		},
		'mobiscrollDateTimeFr' : {
			deps : ['mobiscrollDateTime']
		}
	}
});

require(['require', 'jquery', 'backbone', 'underscore', 'app'], function(require, $,backbone, _, App) {
	$(document).bind("mobileinit", function() {
		console.log("JQuery mobile routing system disabled");
		$.mobile.ajaxEnabled = false;
		$.mobile.linkBindingEnabled = false;
		$.mobile.hashListeningEnabled = false;
		$.mobile.pushStateEnabled = true;
		// Remove page from DOM when it's being replaced
		$('div[data-role="page"]').live('pagehide', function(event, ui) {
			//$(event.currentTarget).remove();
			$.mobile.silentScroll(0);
			if($(event.currentTarget).close)
				$(event.currentTarget).close();
			else{
				$(event.currentTarget).remove();
			}
		});
		window.addEventListener('load', function() {
		    new FastClick(document.body);
		}, false);
		window.addEventListener('orientationchange', function () {
		   // Backbone.history.fragment = null;
		    //Backbone.history.navigate(document.location.hash, true); 
		}, false);
		/*window.addEventListener('resize', function () {
		    Backbone.history.fragment = null;
		    Backbone.history.navigate(document.location.hash, true); 
		}, false);*/
	});
	require(["jquery", "dotdotdot"], function($) {
	    $(function() {
	    
	    });
	});
	require(['jquerymobile'], function($$) {
		// The "app" dependency is passed in as "App"
		App.initialize();
	});
});
