/**
 * A offer model for Contact 
 */
define([
'backbone','textFormatHelper','pamhelper'
],function(Backbone,TextFormatHelper,pamHelper){
	var ContactModel = Backbone.Model.extend({
		defaults: {
		},
		dataInCache : function(options){
			var cachedValue = MyApp.oSessionManager.getCacheValue('contact');
			if(cachedValue){
				console.log('data in cache');
				return JSON.parse(cachedValue);
			}
			console.log('data expired');
			return undefined;
		},
		storeDataInCache : function(data){
			MyApp.oSessionManager.setCacheValue('contact',JSON.stringify(data));
		},
		callWebService : function(){
			var thisObject = this;
			var myAppObject = MyApp;
			pamHelper.sendRestRequest({
				url:  'agence/',
				success: function (data) {
					for(var i in data.Agences)
					{
						var element=data.Agences[i];
						if (element.Telephone != undefined) {
							textFormatHelper = new TextFormatHelper();
							element.TelephoneString = textFormatHelper.formatTelephone(element.Telephone);
						}
						// data.Agences[i]=element;
					}
					thisObject.storeDataInCache(data);
					thisObject.initialiseData(thisObject,data);
				},
				error:function(data,errorMessage){
						window.location.hash ='#contact?error='+errorMessage.LibelleErreur;
				}
			});
		},
		initialiseData: function(callingObject,data) {
			var thisObject = this;
			thisObject.set(data);
			thisObject.change();
		},
		initialize: function(){
			
		},
		initialise: function(){
			console.log('initialize Contact');
			var data = this.dataInCache();
			if(data){
				this.initialiseData(this,data);
			}
			else{
				this.callWebService();
			}
		},		
		modifierPreferencesContact : function(contactSms, contactEmail, contactPush) {
			var thisObject = this;
			var myAppObject = MyApp;
			pamHelper.sendRestRequest({
				url: 'preference/contact',
				type: 'PUT',
				data: JSON.stringify({ ContactSms: contactSms, ContactEmail: contactEmail, ContactPush: contactPush }),
				success: function (data) {
					MyApp.oSessionManager.setValue('ContactSms',JSON.stringify(contactSms));
					MyApp.oSessionManager.setValue('ContactEmail',JSON.stringify(contactEmail));
					MyApp.oSessionManager.setValue('ContactPush',JSON.stringify(contactPush));
					window.location.hash = '#contact';
				}
					
			});
		}
	});
	
	return ContactModel; 
});