/**
 * A offer model for Indisponibilites 
 */
define([
'backbone','dateHelper','pamhelper'
],function(Backbone,DateHelper,pamHelper){
	var IndisponibilitesModel = Backbone.Model.extend({
		defaults: {
		},
		dataInCache : function(options){
			var cachedValue = MyApp.oSessionManager.getCacheValue('indisponibilites');
			if(cachedValue){
				console.log('data in cache');
				return JSON.parse(cachedValue);
			}
			console.log('data expired');
			return undefined;
		},
		storeDataInCache : function(data){
			MyApp.oSessionManager.setCacheValue('indisponibilites',JSON.stringify(data));
		},
		callWebService : function(){
			var thisObject = this;
			var myAppObject = MyApp;
			pamHelper.sendRestRequest({
				url: 'indisponibilite/',
				success: function (data) {
					for(var i in data.Indisponibilites)
					{
						var element=data.Indisponibilites[i];
						if (element.DateDebut != undefined) {
							var dateHelper = new DateHelper();
							element.DateDebut = dateHelper.parseDate(element.DateDebut);
							element.DebutString = dateHelper.formatDateFullYear(element.DateDebut);
						}
						if (element.DateFin != undefined) {
							var dateHelper = new DateHelper();
							element.DateFin = dateHelper.parseDate(element.DateFin);
							element.FinString = dateHelper.formatDateFullYear(element.DateFin);
						}
					}

					thisObject.storeDataInCache(data);
					thisObject.initialiseData(thisObject,data);
				},
				error : function (data,errorMessage){
					window.location.hash ='#indisponibilites?error='+errorMessage.LibelleErreur;
				}
			});
		},
		initialiseData: function(callingObject,data) {
			var thisObject = this;
			thisObject.set(data);
			thisObject.change();
		},
		initialize: function(){
			
		},
		initialise: function(){
			console.log('initialize Indisponibilites');
			var data = this.dataInCache();
			if(data){
				this.initialiseData(this,data);
			}
			else{
				this.callWebService();
			}
		},		
		supprimer : function(idIndisponibilite, callbackOnSuccess, callbackOnError) {
			var thisObject = this;
			var myAppObject = MyApp;
			pamHelper.sendRestRequest({
				url: '/indisponibilite/'+idIndisponibilite,
				type: 'DELETE',
				success: function (data) {
					callbackOnSuccess(data);
				},
				error : function (data,errorMessage){
					callbackOnError(errorMessage);
				}
			});
		},
		ajouter : function(dateDebutPeriode, dateFinPeriode, callbackOnSuccess, callbackOnError) {
			var dateHelper = new DateHelper();
			var thisObject = this;
			var myAppObject = MyApp;
			pamHelper.sendRestRequest({
				url: '/indisponibilite/',
				type: 'POST',
				data: JSON.stringify({ DateDebut: dateHelper.getDateWithRemovedOffset(dateDebutPeriode), DateFin: dateHelper.getDateWithRemovedOffset(dateFinPeriode) }),
				success: function (data) {
					callbackOnSuccess(data);
				},
				error : function (data,errorMessage){
					callbackOnError(errorMessage);
				}
					
			});
		}
	});
	

	return IndisponibilitesModel; 
});