/**
 * A offer model for enCoursSynthese view including the folling attributes :
 * ID : unique id of the offer
 * TitreOffre : title of the offer
 * Debut : Stating date of the offer
 * Fin : Ending date of the offer
 * NomEntreprise : company's name
 * AddresseEntreprise : company's address
 * NomContact : name of the contact in the customer company
 * PosteContact : title of the contact in the customer company
 * TelephoneContact : phone number of the contact in the customer company
 * ContratSigne : true if the contract has been signed * ID : unique id of the offer
 * Status: current status of the offer, can be current, accepted, new, answered or refused. current offers are works that the user currently do.
 */
define([
'backbone','dateHelper','underscore','pamhelper'
],function(Backbone,DateHelper,_,pamHelper){
	var SumOfferModel = Backbone.Model.extend({
	    defaults: {
	    	
	    },
		dataInCache : function(idMission){
			var cachedValue = MyApp.oSessionManager.getCacheValue('synthese_'+idMission);
			if(cachedValue){
				console.log('data in cache');
				return JSON.parse(cachedValue);
			}
			console.log('data expired');
			return undefined;
		},
		storeDataInCache : function(idMission,data){
			MyApp.oSessionManager.setCacheValue('synthese_'+idMission,JSON.stringify(data));
		},
		callWebService : function(idMission){
			var thisObject = this;
			var myAppObject = MyApp;
			pamHelper.sendRestRequest({
				url: 'Mission/' + idMission+'/synthese',
				success: function (data) {
					// EVOL
					// En fonction du type d'OS, parsing de model.synthese contenu (compil en HTML ct serveur).
					// Et ajout du lien vers l'application native Apple plan pour iOS et google Maps pour Android.
					// On rcupere la valeur de l'adresse
					var adresseString = $(data.SyntheseContenu).find('#geolocation').html();
					if(MyApp.oConfig.deviceFamily() ==  "android") {
						// On remplace la valeur de l'adresse dans le lien
						var newHtmlSynthese = data.SyntheseContenu.replace('[{#_GEOLOCVALUE_#}]','geo:0,0?q='+adresseString);
						// On modifie le model
						data.SyntheseContenu = ('SyntheseContenu', newHtmlSynthese);
////						<div class="ContactAgenceAdresse"><a href="geo:0,0?q=<%= agenceDetail.Adresse%>&z=5" data-rel="external"><%= agenceDetail.Adresse%></a></div>
					} else {
						// On remplace la valeur de l'adresse dans le lien
						var newHtmlSynthese = data.SyntheseContenu.replace('[{#_GEOLOCVALUE_#}]','maps:q='+adresseString);
						// On modifie le model
						data.SyntheseContenu = ('SyntheseContenu', newHtmlSynthese);
////					<div class="ContactAgenceAdresse"><a href="maps:q=<%= agenceDetail.Adresse%>" data-rel="external"><%= agenceDetail.Adresse%></a></div>
					}

					if (data.DateDebut != undefined) {
						datehHelper = new DateHelper();
						data.DateDebut = datehHelper.parseDate(data.DateDebut);
						data.DebutString = datehHelper.formatDate(data.DateDebut);
					}
					thisObject.storeDataInCache(idMission,data)
					thisObject.initialiseData(thisObject,data);
				},
				error : function (data,errorMessage){ 
					window.location.hash ='#enCours?error='+errorMessage.LibelleErreur;
				}
			});
		},
		initialiseData: function(callingObject,data) {
			var thisObject = this;
			thisObject.set(data);
			setTimeout(function(){thisObject.change();console.log('change !'+thisObject);},1000);
		},
		initialize: function(){
			
		},
		initialise: function(options){
			var idMission = options.idMission; 
			data = this.dataInCache(idMission);
			if(data){
				this.initialiseData(this,data);
			}
			else{
				this.callWebService(idMission);
			}

		},

		imprevu : function(situation,commentaire) {
			var thisObject = this;
			var myAppObject = MyApp;
			pamHelper.sendRestRequest({
				url: 'Mission/'+thisObject.get('Id')+'/imprevu',
				type: 'POST',
				data: JSON.stringify({ TypeImprevu: situation, Commentaire: commentaire }),
				success: function (data) {
					Backbone.history.navigate('/enCoursSynthese/' + thisObject.get('Id'), true);
				},
				error : function (data,errorMessage){
					if (errorMessage.CodeErreur == 110 || errorMessage.CodeErreur ==404){
						window.location.hash = '#propositions?error='+errorMessage;
					}						
					else if (errorMessage.CodeErreur == 111 || errorMessage.CodeErreur == 112){
						window.location.hash = '#propositions?error='+errorMessage.LibelleErreur;
					}
					else {
						MyApp.openPopup('#dialog', errorMessage);
					}
					
				}
					
			});
		}
	  
	});
	
	return SumOfferModel; 
});