define([], function(){
	
	
	///////////////////////////////
	//: MODULE WEBSQL
	///////////////////////////////
	

	var _webSqlDB = function () {
		// Private properties
		var _dataHolder = {};// Dictionnaire de donn�es synchronis� avec toutes les donn�es
		
		// Private function
		function initDB(tx){
			tx.executeSql('CREATE TABLE IF NOT EXISTS RandstadDB (id unique, data)');
			
			tx.executeSql('SELECT * FROM RandstadDB', [], function(rx, results) {
				for(var i=0; i<results.rows.length; i++) {
					var item = results.rows.item(i);
					_dataHolder[item.id] = item.data;
				}
				console.log(_dataHolder);
			});
		}
		
		// DB initialization
		var dbWebSQL = window.openDatabase("RandstadWebSqlDB", "1.0.0", "RandstadDB", 200000); // WebSqlDb
		dbWebSQL.transaction(initDB, errorCB, successInitCB);

		// PRIVATE Interface
		// Callbacks d'execution
		function successInitCB() {
		}

		function successInsertCB() {
		}
				
		function errorCB(error) {
            console.log("Error "+error.code+" "+error.message);
		}

		// PUBLIC interface
		return {
			insertKeyValue: function(key, value){
				_dataHolder[key] = value
               sqlText = 'INSERT OR REPLACE INTO RandstadDB VALUES (?, ?)';
       dbWebSQL.transaction(
                            function(tx){
                                tx.executeSql(sqlText, [key, value]);
                            },
                            errorCB,
                            successInsertCB);
			},
			readKey: function(key) {
				return _dataHolder[key];
			}
		};
	}();
	
	var _sessionManager = function(){

		//://///////////////////////////////
		//: Fonction de bas niveau 
		//://///////////////////////////////
		// ces functions existent pour pouvoir changer simplement de methode de stockage des donnees
		this.setValue = function(key,value){
			if(typeof(value)=='string')
				window.sessionStorage.setItem(key,value);
			else
				window.sessionStorage.setItem(key,JSON.stringify(value));
		};
		this.getValue = function(key){
			var v = sessionStorage.getItem(key);
			return v;
		};
		this.clearValue = function(key){
			sessionStorage.removeItem(key);
		};
		this.truncate = function(){
			sessionStorage.clear();
		};

		this.setValueLocal = function(key,value){
			if(typeof(value)=='string') {
				_webSqlDB.insertKeyValue(key,value);
			} else {
				_webSqlDB.insertKeyValue(key,JSON.stringify(value));
			}
		};
		
		this.getValueLocal = function(key){
			return _webSqlDB.readKey(key);
		};

		// LOCAL STORAGE
//		this.setValueLocal = function(key,value){
//			if(typeof(value)=='string')
//				window.localStorage.setItem(key,value);
//			else
//				window.localStorage.setItem(key,JSON.stringify(value));
//		};
//		
//		this.getValueLocal = function(key){
//			var v = window.localStorage.getItem(key);
//			return v;
//		};
//		
		//://///////////////////////////////
		//: Accesseurs / setters 
		//://///////////////////////////////
		
		// Connexion de l'user
		this.userConnexion = function( data ){	
			// Parcours des variables que l'on veut sauvegarder
			for ( var rubrique in data ) {
			    // Enregistrement des donnees de l'utilisateur
			    this.setValue(rubrique , data[rubrique]);
			}
			// Ajout d'une cle pour savoir rapidement s'il on est connecte
			this.setValue('connexionStatus','true');
		};
			
		// Deconnexion de l'user
		this.userDeconnexion = function(){
			// Suppression de toutes les donnees relatives a� l'user
			this.truncate();
		};
		
		// Test si l'utilisateur est connecte
		this.isConnected = function(){
			// Retourne vrai si utilisateur connecte ou faux dans le cas contraire
			return this.getValue('connexionStatus')=='true';
			
		};
		
		this.getAutoLogin = function(){
			return this.getValueLocal('autoLogin')=='true';
		}; 
		
		this.setAutoLogin = function(value){
			this.setValueLocal('autoLogin',value);
		}; 
		
		this.getMemoriseLogin = function(){
			return this.getValueLocal('memoriseLogin')=='true';
		}; 
		
		this.setMemoriseLogin = function(value){
			this.setValueLocal('memoriseLogin',value);
		}; 

		this.getLogin = function(){
			return this.getValueLocal('userLogin');
		}; 
		
		this.setLogin = function(value){
			this.setValueLocal('userLogin',value);
		}; 

		this.getPassword = function(){
			return this.getValueLocal('userPassword');
		}; 
		
		this.setPassword = function(value){
			this.setValueLocal('userPassword',value);
		}; 
		
		this.getToken = function () {
		    return this.getValueLocal('session-id');
		};

		this.setToken = function (value) {
		    this.setValueLocal('session-id', value);
		};

		this.getNumVersion = function () {
		    return "1.1";
		};

		this.getApplicationName = function () {
		    return "PAM";
		};

		
		// preferences de contact
		/*
		 "ContactSms" : true,
		 "ContactEmail" : false,
		 "ContactPush": true,
		 */

		this.isSmsAllowed = function(){
			// Retourne vrai si utilisateur autorise les sms ou faux dans le cas contraire
			return this.getValue('ContactSms')=='true';
			
		}; 
		this.isEmailAllowed = function(){
			// Retourne vrai si utilisateur autorise les emails ou faux dans le cas contraire
			return this.getValue('ContactEmail')=='true';
			
		}; 
		this.isPushAllowed = function(){
			// Retourne vrai si utilisateur autorise les push ou faux dans le cas contraire
			return this.getValue('ContactPush')=='true';
		}; 
		
		// session informations
		this.getSessionToken = function(){
			// Retourne le token de session de l'utilisateur
			return this.getValue('sessionToken');
		}; 
		
		this.setSessionToken = function(theToken){
			this.setValue('sessionToken',theToken);
		};


		
		//information device
		this.getDeviceToken = function(){
			// Retourne le token de session de l'utilisateur
			if (this.getValueLocal('deviceToken') == null) return "";
			return this.getValueLocal('deviceToken');
		}; 
		
		this.setDeviceToken = function(theToken){
			this.setValueLocal('deviceToken',theToken);
		};
		this.getPushToken = function(){
			// Retourne le token de session de l'utilisateur
			return this.getValue('pushToken');
		}; 
		
		this.setPushToken = function(theToken){
			this.setValue('pushToken',theToken);
		};
		
		// cacheManager
		this.setCacheValue = function(customKey, theValue){
			console.log('Mise en Cache pour ' + customKey);
			var objectToStore = {date:new Date(),value: theValue} 
			this.setValue(customKey,JSON.stringify(objectToStore));
		};
		this.getCacheValue = function(customKey){
			var objectStored = this.getValue(customKey);
			
			if(objectStored){
				objectStored = $.parseJSON(objectStored);
				storageDate = new Date(objectStored.date);
				now = new Date();
				expirationDate = new Date(storageDate.getTime()+MyApp.oConfig.cacheTTL());
		
				if (now.getTime()<(storageDate.getTime()+MyApp.oConfig.cacheTTL())){
					console.log('Cache pour ' + customKey + ' expirera en date du :'+ expirationDate);
					return objectStored.value;
				}
				console.log('Cache pour ' + customKey + ' expiré' );
			} else {
				console.log('Cache pour ' + customKey + ' inexistant');
			}
			return undefined;
		};
		this.clearCacheValue = function(customKey){
			this.clearValue(customKey);
		};
		//get or set the preferences 
		this.setPlanningAutocommit = function(user, value){
			if(value) {
				this.setValueLocal('autoPlanningcommit' + user, 'true');
			}
			else{
				this.setValueLocal('autoPlanningcommit' + user, 'false');
			}
		};
		
		this.getPlanningAutocommit = function(user){
			return this.getValueLocal('autoPlanningcommit' + user) == 'true';
		};
		//get or set asked page before displaying auth
		this.setAskedPage = function(value){
			this.setValue('askedPage', value);
		};
		this.getAskedPage = function(){
			return this.getValue('askedPage');
		};
		this.clearAskedPage = function(){
			this.clearValue('askedPage');
		};
		//get or set error to be displayed
		this.setErrorMessageToDisplay = function(value){
			this.setValue('errorMessage', value);
		};
		this.getErrorMessageToDisplay = function(){
			return this.getValue('errorMessage');
		};
		this.clearErrorMessageToDisplay = function(){
			this.clearValue('errorMessage');
		};
		//get or set the current displayed mission service in order to find it in the planning
		this.setCurrentMissionSevice = function(value){
			this.setValueLocal('currentMissionSevice', value);
		};
		this.getCurrentMissionSevice = function(){
			return this.getValueLocal('currentMissionSevice');
		};
		// Utilisé pour l'affichage du nom dans l'acceptation partielle du planning lorsque planning n'est pas renseigné
		this.setCurrentMissionEntreprise = function(value){
			this.setValueLocal('currentMissionEntreprise', value);
		};
		this.getCurrentMissionEntreprise = function(){
			return this.getValueLocal('currentMissionEntreprise');
		};
	};

	return _sessionManager;

}
);