define(['jquery', 'underscore', 'backbone', 'swipejs', 'moment', 'pamhelper','generic' ,
        'text!templates/acceptationPlanning.html', 'text!templates/commons/headerSmall.html', 'text!templates/commons/footer.html', 'text!templates/planning/planningTables.html',
        'models/MissionPlanningModel', 'text!templates/auth/auth_dialog.html'], function($, _, Backbone, Swipejs, Moment, pamHelper, GenericView, tmpPlanning, tmpHeaderSmall, tmpFooter, tmpPlanningTables, missionPlanningModel,tmpDialog) {
	var view = GenericView.extend({
		events: {
			'click #PlanningValidateButton' : 'openPopupOK',
			'click #PlanningAcceptAllButton' : 'OkForAll',
			'click #previousButton' : 'swipePreviousWeek',
			'click #nextButton' : 'swipeNextWeek',
			'click #SendPlanningOKbtn' : 'planningPopupOK',
			'click #SendPlanningCancelbtn' : 'planningPopupCancel',
			'click .SelectableCell' : 'changeCellState',
			'click #ErrordialogOKbtn' : 'closeErrorPopup',
			'click .FooterContainer' : 'checkIfNotUnsavedChanges',
			'tap .FooterLink' : 'checkIfNotUnsavedChangesActivation',
			'click #NonSavedChangesAcceptationOKbtn' : 'NotCommitedDialogOKHandler',
			'click #NonSavedChangesAcceptationCancelbtn' : 'NotCommitedDialogCancelHandler'
		},
		transition: 'fade',
		name:'acceptationPlanning',
		initialize : function(args) {
			console.log("Initialisation Vue ".concat(this.name));
			this.mission = args.idMission;
			this.planningAccessMode = args.planningAccessMode;
			$.mobile.showPageLoadingMsg("b");
			moment.lang('fr', {months : "janvier_février_mars_avril_mai_juin_juillet_août_septembre_octobre_novembre_décembre".split("_")});
			this.events = _.extend({}, this.genericEvents, this.events);
			this.delegateEvents();
			$.mobile.showPageLoadingMsg("b");
			_.bindAll(this, 'render');
			_.bindAll(this, 'renderData');
			_.bindAll(this, 'slideChanged');
			_.bindAll(this, 'initializeSwipe');
			_.bindAll(this, 'openPopupOK');
			_.bindAll(this, 'closeErrorPopup');
			_.bindAll(this, 'planningPopupOK');
			_.bindAll(this, 'swipePreviousWeek');
			_.bindAll(this, 'swipeNextWeek');
			_.bindAll(this, 'changeCellState');
			_.bindAll(this, 'checkIfNotUnsavedChanges');
			_.bindAll(this, 'checkIfNotUnsavedChangesActivation');
			_.bindAll(this, 'NotCommitedDialogOKHandler');
			_.bindAll(this, 'NotCommitedDialogCancelHandler');
			if (args.accessMode == 'readOnlyEnCours'){
				this.readOnlyMission = args.idMission;
				this.access = 'enCours';
			}
			else if (args.accessMode == 'readOnlyProposition'){
				this.readOnlyMission = args.idMission;
				this.category = 'propositions';
			}
			else if (args.accessMode == 'readOnly'){
				this.readOnlyMission = args.idMission;
				this.category = 'propositions';
			}
			else{
				this.readOnlyMission = undefined;
				this.category = 'propositions';
			}
			this.model = new missionPlanningModel;
			this.model.bind('change', this.renderData);
			this.model.initialise(args.idMission);
			console.log("Sortie Initialisation Vue ".concat(this.name));
		},
		render : function() {
			console.log("Rendu Vue ".concat(this.name));
			var planningModel = this.model != undefined ? this.model.attributes : undefined;
			var missionFirstDay = this.model.getFirstMissionDay(moment, this.getMomentDateFromISO);

			// Si le nom du service n'est pas renseigné
			// on affiche le nom de l'entreprise
			if(MyApp.oSessionManager.getCurrentMissionSevice() != undefined && MyApp.oSessionManager.getCurrentMissionSevice() != 'undefined' && MyApp.oSessionManager.getCurrentMissionSevice() != "null" && MyApp.oSessionManager.getCurrentMissionSevice() != null){
				var missionTitle = MyApp.oSessionManager.getCurrentMissionSevice();
			}else{
				var missionTitle = MyApp.oSessionManager.getCurrentMissionEntreprise();
			}
			missionTitle += ', ';
			//var missionTitle = (MyApp.oSessionManager.getCurrentMissionSevice() != undefined && MyApp.oSessionManager.getCurrentMissionSevice() != 'undefined' && MyApp.oSessionManager.getCurrentMissionSevice() != "null") ? : '';

			if (missionFirstDay != undefined){
				var title = missionTitle + this.model.getFirstMissionDay(moment, this.getMomentDateFromISO).format('DD/MM') + ' - ' + this.model.getLastMissionDay(moment, this.getMomentDateFromISO).format('DD/MM');
			} else{
				var title = "";
			}
			$(this.el).append(_.template(tmpPlanning, { planning: planningModel, label: title, category: this.category, readOnlyMission: this.readOnlyMission, planningAccessMode:this.planningAccessMode, smallHeaderTemplate: _.template(tmpHeaderSmall), footerTemplate: _.template(tmpFooter),authDialog : _.template(tmpDialog), planningTables : _.template(tmpPlanningTables), getMomentDateFromISO: this.getMomentDateFromISO }));

			var thisObject = this;
			$.mobile.showPageLoadingMsg("b");
			$(this.el).live('pageshow',function(event, ui){
				thisObject.initializeSwipe(0);
				thisObject.HideDisplayPlanningArrows();
			});
			pamHelper.showNbUnreadMissionsBadge(this.el);
			console.log("Sortie Rendu Vue ".concat(this.name));
			return this.el;
		},
		initializeSwipe : function (indexNumber) {
			$.mobile.showPageLoadingMsg("b");
			this.swipe = new Swipe(document.getElementById('PlanningWeeksContainer'), {
				callback: this.slideChanged,
				startSlide: indexNumber + ''
			});
			var weekDate = this.getMomentDateFromISO(this.model.attributes.Plannings[indexNumber].Annee, this.model.attributes.Plannings[indexNumber].Semaine, 1);
			$('#PlanningWeekHeaderText').text('S' + weekDate.isoWeek() + ' ' + weekDate.format('MMMM') + ' ' + weekDate.isoWeekYear());
			$(".creneauMission").dotdotdot();
			$.mobile.hidePageLoadingMsg();
		},
		slideChanged : function(index, slide) {
			// Check if data should be loaded for the next/previous week
			console.log('slide changed');
			var weekDate = this.getMomentDateFromISO(this.model.attributes.Plannings[index].Annee, this.model.attributes.Plannings[index].Semaine, 1);
			$('#PlanningWeekHeaderText').text('S' + weekDate.isoWeek() + ' ' + weekDate.format('MMMM') + ' ' + weekDate.isoWeekYear());
			this.HideDisplayPlanningArrows();
		},
		HideDisplayPlanningArrows : function() {
			if (this.swipe.getPos() == 0){
				$('#previousButton').addClass('PlanningHiddenButton');
			}
			else {
				$('#previousButton').removeClass('PlanningHiddenButton');
			}
			if (this.swipe.getPos() == this.swipe.getNumSlides() - 1){
				$('#nextButton').addClass('PlanningHiddenButton');
			}
			else {
				$('#nextButton').removeClass('PlanningHiddenButton');
			}
		},
		OkForAll : function() {
			for (var week = 0; week < this.model.attributes.Plannings.length; week++) {
				for (var day = 0; day < 7; day ++){
					for (var daytime = 0; daytime < 3; daytime ++){
						if(this.model.attributes.Plannings[week].Planning[day][daytime].Statut == "aRenseigner" ||
								this.model.attributes.Plannings[week].Planning[day][daytime].Statut == "refuse"){
							this.model.attributes.Plannings[week].Planning[day][daytime].Statut = 'accepte';
							this.model.attributes.Plannings[week].Planning[day][daytime].Modifie = true;
							var cell = $('#Cell_' + week + '_' + day + '_' + daytime);
							cell.removeClass('PlanningCellToBeAnswered');
							cell.removeClass('PlanningCellDeclined');
							cell.addClass('PlanningCellAccepted')
						}
					}
				}
			}
		},
		validate : function(source) {
			$.mobile.showPageLoadingMsg();
			var thisObject = this;
			this.model.commitWeek(
					function(data){
						MyApp.openPopup('#dialog','Envoi du planning réussi');
						// Sur acceptaiton, on Vidage le cache afin de recharger la mission et recalculer statuts des cr�neaux
						MyApp.oSessionManager.clearCacheValue('planningMission_'+ thisObject.model.idMission);
						MyApp.oSessionManager.clearCacheValue("details_"+ thisObject.model.idMission);
						MyApp.oSessionManager.clearCacheValue("mission");
						window.location.hash = '#propositions';
					},function(data,errorMessage){
            $.mobile.hidePageLoadingMsg();
						MyApp.oSessionManager.clearCacheValue("mission");
						if(errorMessage.CodeErreur == 83) {
							thisObject.mustReload = true;
						}
						if(errorMessage.LibelleErreur){
							MyApp.openPopup('#Errordialog',errorMessage.LibelleErreur);
						}
						else{
							MyApp.openPopup('#Errordialog', MyApp.oLocale.planning.error.general);
						}
					}
			);
		},
		openPopupOK : function() {
			if (this.model.isPlanningNonAllAnswered()) {
				$('#PlanningErrorMessage').text('Veuillez accepter/refuser tous les créneaux disponibles avant de valider');
				$('body').css('overflow', 'hidden');
				$('#Errordialog').popup('open');
			}
			else{
				$('#validationMessage').text('Confirmez-vous vos réponses sur les ' +
						this.model.attributes.NbCasesAValider + ' cases de la mission du ' +
						this.model.getFirstMissionDay(moment, this.getMomentDateFromISO).format('DD MMMM') + ' au ' +
						this.model.getLastMissionDay(moment, this.getMomentDateFromISO).format('DD MMMM') + ' ?');
				$('body').css('overflow', 'hidden');
				$('#SendPlanningdialog').popup('open');
			}

		},
		planningPopupOK : function() {
			$('body').css('overflow', 'auto');
			$('#SendPlanningdialog').popup('close');
			this.validate();
		},
		planningPopupCancel : function() {
			$('body').css('overflow', 'auto');
			$('#SendPlanningdialog').popup('close');
		},
		swipePreviousWeek : function() {
			this.swipe.prev();
		},
		swipeNextWeek : function() {
			this.swipe.next();
		},
		closeErrorPopup : function() {
			if(this.mustReload){
				Backbone.history.navigate('acceptationPlanning/' + this.mission + "/" + this.planningAccessMode, true);
			}
			else {
				$('body').css('overflow', 'auto');
				$('#Errordialog').popup('close');
			}
		},
		changeCellState : function(source){

			if(this.readOnlyMission) {
				return;
			}
			var cellArgs = source.currentTarget.id.split('_');
			var cellule = this.model.attributes.Plannings[cellArgs[1]].Planning[cellArgs[2]][cellArgs[3]];
			cellule.Modifie = true;
			switch (cellule.Statut) {
				case 'aRenseigner': cellule.Statut = 'accepte';
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).removeClass('PlanningCellToBeAnswered');
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).addClass('PlanningCellAccepted');break;
				case 'accepte':cellule.Statut = 'refuse';
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).removeClass('PlanningCellAccepted');
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).addClass('PlanningCellDeclined');break;
				case 'refuse': cellule.Statut = 'accepte';
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).removeClass('PlanningCellDeclined');
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).addClass('PlanningCellAccepted');break;
			}
		},
		checkIfNotUnsavedChanges : function(event){
			if(this.model.hasSomeCellsAnswered()){
				this.currentFooterTarget = $(event.target).closest(".FooterLink").attr('href');
				event.preventDefault();
				$('body').css('overflow', 'hidden');
				$('#NonSavedChangesAcceptationdialog').popup('open');
			}
		},
		checkIfNotUnsavedChangesActivation : function(event){
			if(this.model.hasSomeCellsAnswered()){
				event.stopImmediatePropagation();
			}
		},
		NotCommitedDialogOKHandler : function(){
			window.location.hash = this.currentFooterTarget;
			$('body').css('overflow', 'auto');
			$('#NonSavedChangesAcceptationdialog').popup('close');
		},
		NotCommitedDialogCancelHandler : function(){
			$('body').css('overflow', 'auto');
			$('#NonSavedChangesAcceptationdialog').popup('close');
		},
		/**
		 * returns a momenjs date instace from the ISO year and ISO week
		 * year, number : ISO year of the date
		 * week, number : ISO week of the date
		 * day, number : number of the day in the week (sunday is 0)
		 */
		getMomentDateFromISO : function(year, week, day){
			if(week < 10){
				week = '0' + week;
			}
			return moment(year + '-W' + week + '-' + day);
		}
	});

	return view;
});
