define(['jquery', 'underscore', 'backbone', 'pamhelper', 'md5', 'text!templates/auth.html', 'text!templates/commons/header.html', 'text!templates/commons/footer.html', 'text!templates/auth/auth_dialog.html'],
    function ($, _, Backbone, pamHelper, MD5, tmpAuth, tmpHeader, tmpFooter, tmpDialog) {
    var view = Backbone.View.extend({
        transition: 'fade',
        events: {
            "click #AuthButton": "AuthUser",
            "click #PwdForgotten": "PwdForgotten",
            "click #closebtn": "closePopup",
            "click #ErrorClosebtn": "closePopupError",
        },
        name:'auth',
        decode: function (error) {
            return error.replace('%20', ' ').replace('%C3%A9', 'é').replace('%C3%8A', 'Ê');
        },
        initialize: function (options) {
            console.log("Initialisation Vue ".concat(this.name));
            //_.bindAll(this, 'nextPage');
            _.bindAll(this, 'render');
            if (MyApp.oSessionManager.getAutoLogin() == true) {
                console.log('AutoLogin :' + MyApp.oSessionManager.getAutoLogin());
                var email = MyApp.oSessionManager.getLogin();
                var password = MyApp.oSessionManager.getPassword();
                this.connectUser(email, password, 'true');
            }
            else {
                MyApp.oMissionManager.disconnect();
            }
            if (options) {
                this.render();
                if (options.message) {
                    this.message = unescape(options.message);
                    MyApp.oSessionManager.truncate();
                    MyApp.oSessionManager.setAutoLogin('false');
                }
                var thisObject = this;
                $(this.el).live('pageshow', function (event, ui) {
                    thisObject.showMessage();
                });
            }


            // SHAMELESS
            // MyApp.oConfig.serverAddress = function () {
            //     return 'https://api-mobilite.grouperandstad.fr';
            // }
            //

        },
        showMessage: function () {
            if (MyApp.oSessionManager.getErrorMessageToDisplay() != undefined) {
                MyApp.openPopup("#Errordialog", MyApp.oSessionManager.getErrorMessageToDisplay());
                MyApp.oSessionManager.clearErrorMessageToDisplay();
            }
            if (this.message != undefined) {
                if (this.message == MyApp.oLocale.auth.disconnected || this.message == MyApp.oLocale.common.error.serverError) {
                    this.openPopup('#Errordialog', this.message);
                }
                else {
                    this.setErrorLine(this.message);
                }
            }
            console.log("Sortie Initialisation Vue ".concat(this.name));
        },
        render: function () {
            console.log("Rendu Vue ".concat(this.name));
            $.mobile.hidePageLoadingMsg();
            $(this.el).append(_.template(tmpAuth, { headerTemplate: _.template(tmpHeader), footerTemplate: _.template(tmpFooter), authDialog: _.template(tmpDialog) }));
            $('body').append($(this.el));
            $.mobile.changePage($(this.el), {
                changeHash: false,
                transition: 'none'
            });
            console.log("Sortie Rendu Vue ".concat(this.name));

            
            return this.el;

        },
        checkUserEmail: function (email) {
            var re = /\S+@\S+\.\S+/;
            return re.test(email);
        },
        checkUserPassword: function (password) {
            return password != '';
        },
        updateUIBadEmail: function () {
            this.updateUIBadField('email');
            this.setErrorLine(MyApp.oLocale.auth.error.badEmail);
        },
        updateUIBadPassword: function () {
            this.updateUIBadField('pwd');
            this.setErrorLine(MyApp.oLocale.auth.error.badPassword);
        },
        updateUIBadField: function (fieldId) {
            //$('#'+fieldId).addClass('error');
            $('label[for="' + fieldId + '"]').addClass('error');
        },
        setErrorLine: function (text) {
            if (text && text != '') {
                $("#errorLine").text(text);
                $("#errorLine").show();
            }
            else {
                $("#errorLine").text('');
                $("#errorLine").hide();
            }
        },
        updateUIOkEmail: function () {
            this.updateUIOkField('email');
            this.setErrorLine('');
        },
        updateUIOkPassword: function () {
            this.updateUIOkField('pwd');
            this.setErrorLine('');

        },
        updateUIOkField: function (fieldId) {
            $('#' + fieldId).removeClass('error');
            $('label[for="' + fieldId + '"]').removeClass('error');
        },
        openPopup: function (element_id, text) {
            $('body').css('overflow', 'hidden');
            if (text != '') {
                $(element_id + ' div p').text(text);
                $(element_id).popup();
                $(element_id).popup('open');
            }
        },
        saveUserCredential: function (login, password, memorize, token) {
            MyApp.oSessionManager.setAutoLogin(memorize);
            MyApp.oSessionManager.setMemoriseLogin(memorize);
            MyApp.oSessionManager.setToken(token);
            if (memorize) {
                MyApp.oSessionManager.setLogin(login);
                MyApp.oSessionManager.setPassword(password)
            } else if (login != MyApp.oSessionManager.getLogin() ||
					password != MyApp.oSessionManager.getPassword()) {
                // Si les identifiants pass�s en param�tres ne sont pas les m�mes
                // que ceux m�moris�s. on clear le cache
                MyApp.oSessionManager.setLogin('');
                MyApp.oSessionManager.setPassword('');
            }
        },
        closePopup: function () {
            $('body').css('overflow', 'auto');
            $('#dialog').popup('close');
            if (MyApp.oSessionManager.isConnected())
                this.nextPage()
        },
        closePopupError: function () {
            $('body').css('overflow', 'auto');
            $('#Errordialog').popup('close');
        },
        nextPage: function (viewName, parameters) {
            try {
                //Prise en compte du cas où l'utilisateur a été redirigé sur la pas d'auth depuis une autre page
                //if(!viewName && MyApp.oSessionManager.getAskedPage() != undefined && MyApp.oSessionManager.getAskedPage() != ""){
                //	Backbone.history.navigate(MyApp.oSessionManager.getAskedPage(), true);
                //	MyApp.oSessionManager.clearAskedPage();
                //}
                //else {
                if (viewName && viewName != "") {
                    var nextPage = viewName;
                    if (parameters && parameters != "")
                        Backbone.history.navigate(nextPage + '/' + parameters, true);
                    else
                        Backbone.history.navigate(nextPage, true);
                } else {

                     var nextPage = viewName || 'enCours';
                    MyApp.oMissionManager.getMissions(function(missions) {

                        var currentMissions = missions.GetCurrentOffers();
                        switch (currentMissions.length) {
                            case 0: nextPage = 'propositions';
                            break;
                            case 1: nextPage = 'enCoursSynthese/' + currentMissions[0].get('Id');
                            break;
                        }
                        Backbone.history.navigate(nextPage, true);
                    },function(data,errorMessage) {
                        Backbone.history.navigate('contact?error=' + errorMessage.LibelleErreur, true);
                    });
                }
            } catch (e) {
                this.setErrorLine(e);
            }
        },
        connectUserWithPreviousAuthen: function () {
            var sessionManager = MyApp.oSessionManager;
            var email = sessionManager.getLogin();
            var password = sessionManager.getPassword();
            var memorize = true;
            this.connectUser(email, password, memorize);
        },
        sucessConnexion: function (email, password, memorize, data) {
            var upToDate = true;
            var serviceUnvalaible = false;
            var message = data.Message;

            this.saveUserCredential(email, password, memorize, data.token);
            MyApp.oSessionManager.setSessionToken('true');
            MyApp.oSessionManager.setLogin(email);
            MyApp.oSessionManager.userConnexion(data);
            if (message && message.Fr != '') {
                this.openPopup('#dialog', message.Fr);
            }
            else {

                //if data.MotDePasseTemporaire == true; inciter la perso du mdp
                if (data && data.MotDePasseTemporaire && data.MotDePasseTemporaire == true)
                    this.nextPage('customPwd', email);
                else
                    this.nextPage();
            }

        },
        connectUser: function (email, password, memorize) {
            var self = this;

            // SHAMELESS
            // if (email == "validationapple@gmail.com") {
            //     MyApp.oConfig.serverAddress = function () {
            //         return 'https://recette.api-mobilite.grouperandstad.fr';
            //     }
            // }
            // console.log(MyApp.oConfig.serverAddress());
            //

            var myAppObject = MyApp;
            console.log('auth with push token : ' + JSON.stringify(MyApp.oSessionManager.getDeviceToken()));

            pamHelper.sendRestRequest({
                url: 'authpam/Authentification/Auth',
                type: 'POST',
                data: JSON.stringify({ Identifiant: email, MotDePasse: password, ConfirmMotDePasse: "", DeviceID: MyApp.oSessionManager.getDeviceToken(), DeviceName: MyApp.oConfig.deviceName(), VersionAppli: MyApp.oConfig.appVersion(), CodeMarque: MyApp.oConfig.marque(), DeviceFamily: MyApp.oConfig.deviceFamily() }),

                success: function (data) {
                    self.sucessConnexion(email, password, memorize, data);

                    // Si l'authentification a bien eu lieu
                    // On teste si on doit mettre à jour la valeur de Push (Premier lancement de l'application)
                    // Synchronisation Backend
                    if (MyApp.oConfig.firstLaunch == true) {
                        MyApp.oSessionManager.setValue('ContactPush', true);

                        pamHelper.sendRestRequest({
                            url: 'preference/contact',
                            type: 'PUT',
                            data: JSON.stringify({ ContactSms: data.ContactSms, ContactEmail: data.ContactEmail, ContactPush: 'true' }),
                            success: function (data) {
                                MyApp.oConfig.firstLaunch = false;
                            }
                        });
                    }
                }
            });
        },

        PwdForgotten: function () {
            var email = $('#email').val();
            if (this.checkUserEmail(email))
                MyApp.oSessionManager.setLogin(email);

            this.nextPage('checkUserEmail', email);
        },
        AuthUser: function () {
            var sessionManager = MyApp.oSessionManager;
            var email = $('#email').val();
            var password = $('#pwd').val();
            var memorize = $('#MemoriseIds').attr('checked') == 'checked';

            if (!this.checkUserEmail(email)) {
                this.updateUIBadEmail();
                return;
            }
            else {
                this.updateUIOkEmail();
            }
            if (!this.checkUserPassword(password)) {
                this.updateUIBadPassword();
                return;
            }
            else {
                this.updateUIOkPassword();
            }

            this.connectUser(email, password, memorize);
        },

    });

    return view;
});
