define(['jquery', 'underscore', 'backbone', 'pamhelper', 'generic', 'dotdotdot',
        'text!templates/changeEmail.html', 'text!templates/commons/header.html', 'text!templates/commons/footer.html',
         'text!templates/auth/auth_dialog.html'],
        function ($, _, Backbone, pamHelper, GenericView, dotdotdot, tmpChEmail, tmpHeader, tmpFooter, tmpDialog) {
            var view = GenericView.extend({
                transition: 'fade',
                error: undefined,
                name:'changeEmail',
                events: {
                    "click #ConfirmChangeEmail": "confirmChangeEmail",
                    "click #ErrorClosebtn": "closePopupError"
                },
                initialize: function (options) {
                    console.log("Initialisation Vue ".concat(this.name));
                    this.events = _.extend({}, this.genericEvents, this.events);
                    this.delegateEvents();
                    $.mobile.showPageLoadingMsg("b");
                    if (options && options.email) {
                        this.email = options.email;
                    }
                    else {
                        this.email = MyApp.oSessionManager.getLogin();
                    }
                    console.log("Sortie Initialisation Vue ".concat(this.name));

                },

                render: function () {
                    console.log("Rendu Vue ".concat(this.name));
                    //Adding underscore compliant templates for footer and header
                    $(this.el).append(_.template(tmpChEmail, { headerTemplate: _.template(tmpHeader), authDialog: _.template(tmpDialog), footerTemplate: _.template(tmpFooter), _: _ }));
                    

                    $.mobile.hidePageLoadingMsg();

                    this.afterRender();
                    console.log("Sortie Rendu Vue ".concat(this.name));
                    pamHelper.showNbUnreadMissionsBadge(this.el);
                    return this;
                },
                afterRender : function(){
                    $('#oldemail').val(this.email);
                },
                closePopup: function () {
                    MyApp.oSessionManager.clearErrorMessageToDisplay();
                    var path = window.location.pathname;
                    window.history.replaceState({}, 'foo', path + "#propositions");
                    $('#dialog').popup('close');
                },
                confirmChangeEmail: function () {

                    //Check values 
                    if (this.checkLogins($('#newemail').val(), $('#newemailconfirm').val())) {
                        //getEmail
                        //Call to saveNewPassword
                        this.saveNewLogin(this.email, $('#pwd').val(), $('#newemail').val(), $('#newemailconfirm').val());
                    }
                    else {
                        // Error was trapped in checkPasswords
                    }
                },
                closePopup: function () {
                    MyApp.oSessionManager.clearErrorMessageToDisplay();
                    var path = window.location.pathname;
                    window.history.replaceState({}, 'foo', path + "#propositions");
                    $('#dialog').popup('close');
                },
                checkLogins: function (login, loginconfirm) {
                    if (!login && !loginconfirm) {
                        this.updateUIBadField('newemail');
                        this.updateUIBadField('newemailconfirm');
                        this.setErrorLine(MyApp.oLocale.passwordChange.error.empty);
                        return false;
                    }
                    else {
                        if ((login && login.trim() == "") || (loginconfirm && loginconfirm.trim() == "")) {
                            this.updateUIBadField('newemail');
                            this.updateUIBadField('newemailconfirm');
                            this.setErrorLine(MyApp.oLocale.loginChange.error.empty);
                            return false;
                        }
                        else {
                            if (login != loginconfirm) {
                                this.updateUIBadField('newemailconfirm');
                                this.setErrorLine(MyApp.oLocale.loginChange.error.missmatch);
                                return false;
                            }
                            else {
                                //Regex are server sides
                                //success 
                                this.updateUIOKPass();
                                this.updateUIOkNLogin();
                                this.updateUIOkNLoginConfirm();
                                return true;
                            }
                        }
                    }
                },
                updateUIOKPass: function () {
                    this.updateUIOkField('pwd');
                    this.setErrorLine('');
                },
                updateUIOkNLogin: function () {
                    this.updateUIOkField('newemail');
                    this.setErrorLine('');

                },
                updateUIOkNLoginConfirm: function () {
                    this.updateUIOkField('newemailconfirm');
                    this.setErrorLine('');

                },
                updateUIOkField: function (fieldId) {
                    $('#' + fieldId).removeClass('error');
                    $('label[for="' + fieldId + '"]').removeClass('error');
                },
                updateUIBadField: function (fieldId) {
                    //$('#'+fieldId).addClass('error');
                    $('label[for="' + fieldId + '"]').addClass('error');
                },
                setErrorLine: function (text) {
                    if (text && text != '') {
                        $("#errorLine").text(text);
                        $("#errorLine").show();
                    }
                    else {
                        $("#errorLine").text('');
                        $("#errorLine").hide();
                    }
                },
                openPopup: function (element_id, text) {
                    $('body').css('overflow', 'hidden');
                    if (text != '') {
                        $(element_id + ' div p').text(text);
                        $(element_id).popup();
                        $(element_id).popup('open');
                    }
                },
                saveNewLogin: function (login, password, newlogin, newloginconfirm) {
                    var self = this;
                    var myAppObject = MyApp;
                    pamHelper.sendRestRequest({
                        url: 'authpam/Authentification/CheckEmailModif/',
                        type: 'POST',
                        data: JSON.stringify({ UserEmail: login, UserPassword: password, QuestionId: "", Answer: "", OldValue: login, NewValue: newlogin, ConfirmNewValue: newloginconfirm, ActionType: "CHANGEMENT_LOGIN", BrandCode: MyApp.oConfig.marque() }),
                        success: function (data) {
                            $.mobile.hidePageLoadingMsg();
                            if (data.CodeRetour == "" && data.LibelleRetour == "") {
                                MyApp.oSessionManager.setLogin($('#newlogin').val());
                                self.nextPage('secretQuestion', [login, 'checkchangelogin', login, newlogin, newlogin]);
                                //empécher l'auth silencieuse ?
                            }
                            else {
                                self.openPopup('#Errordialog', myAppObject.oLocale.common.error);
                            }
                        }
                    });
                },
                closePopup: function () {
                    $('body').css('overflow', 'auto');
                    $('#dialog').popup('close');
                    $.mobile.showPageLoadingMsg("b");

                },
                closePopupError: function () {
                    $('body').css('overflow', 'auto');
                    $('#Errordialog').popup('close');
                },
                updateUIBadField: function (fieldId) {
                    //$('#'+fieldId).addClass('error');
                    $('label[for="' + fieldId + '"]').addClass('error');
                },
                nextPage : function(viewName, params){
                    try {
                        var paramToStr = "";
                        for (var i = 0; i < params.length; i++)
                            paramToStr += '/' + params[i];


                        Backbone.history.navigate(viewName + paramToStr, true);
                            

                    } catch (e) {
                        this.setErrorLine(e);
                    }
                },
                setErrorLine: function (text) {
                    if (text && text != '') {
                        $("#errorLine").text(text);
                        $("#errorLine").show();
                    }
                    else {
                        $("#errorLine").text('');
                        $("#errorLine").hide();
                    }
                },
                openPopup: function (element_id, text) {
                    $('body').css('overflow', 'hidden');
                    if (text != '') {
                        $(element_id + ' div p').text(text);
                        $(element_id).popup();
                        $(element_id).popup('open');
                    }
                },
            });

            return view;
        });
