define(['jquery', 'underscore', 'backbone', 'pamhelper', 'generic', 'dotdotdot',
        'text!templates/changePassword.html', 'text!templates/commons/header.html', 'text!templates/commons/footer.html',
         'text!templates/auth/auth_dialog.html'],
        function ($, _, Backbone, pamHelper, GenericView, dotdotdot, tmpChpassword, tmpHeader, tmpFooter, tmpDialog) {
            var view = GenericView.extend({
                transition: 'fade',
                error: undefined,
                name:'changePassword',
                events: {
                    "click #ConfirmChangePwd": "confirmChangePassword",
                        "click #ErrorClosebtn": "closePopupError"
                },
                initialize: function (options) {
                    console.log("Initialisation Vue ".concat(this.name));
                    this.events = _.extend({}, this.genericEvents, this.events);
                    this.delegateEvents();
                    $.mobile.showPageLoadingMsg("b");
                    if (options && options.email) {
                        this.email = options.email;
                    }
                    else {
                        this.email = MyApp.oSessionManager.getLogin();
                    }
                    console.log("Sortie Initialisation Vue ".concat(this.name));

                },
                closePopupError: function () {
                    $('body').css('overflow', 'auto');
                    $('#Errordialog').popup('close');
                    if (this.redirectToLogin == true)
                        Backbone.history.navigate("auth", true);
                },
                render: function () {
                    console.log("Rendu Vue ".concat(this.name));
                    //Adding underscore compliant templates for footer and header
                    $(this.el).append(_.template(tmpChpassword, { headerTemplate: _.template(tmpHeader), authDialog: _.template(tmpDialog), footerTemplate: _.template(tmpFooter), _: _ }));


                    $.mobile.hidePageLoadingMsg();
                    pamHelper.showNbUnreadMissionsBadge(this.el);
                    this.afterRender();

                    console.log("Sortie Rendu Vue ".concat(this.name));
                    return this;
                },
                afterRender: function () {
                    $('#email').val(this.email);
                },
                closePopup: function () {
                    MyApp.oSessionManager.clearErrorMessageToDisplay();
                    var path = window.location.pathname;
                    window.history.replaceState({}, 'foo', path + "#propositions");
                    $('#dialog').popup('close');
                },
                confirmChangePassword: function () {
                    //Check values
                    if (this.checkPasswords($('#oldpwd').val(), $('#newpwd').val(), $('#newpwdconfirm').val())) {
                        //getEmail
                        //Call to saveNewPassword
                        this.saveNewPassword(this.email, $('#oldpwd').val(), $('#newpwd').val());
                    }
                    else {
                        // Error was trapped in checkPasswords
                    }
                },
                checkPasswords: function (oldPass, pass, passconfirm) {
                    if (!pass && !passconfirm && !oldPass) {
                        this.updateUIBadField('oldpwd');
                        this.updateUIBadField('newpwd');
                        this.updateUIBadField('newpwdconfirm');
                        this.setErrorLine(MyApp.oLocale.passwordChange.error.empty);
                        return false;
                    }
                    else {
                        if (oldPass.trim() == "" || pass.trim() == ""|| passconfirm.trim() == "") {
                            this.updateUIBadField('oldpwd');
                            this.updateUIBadField('newpwd');
                            this.updateUIBadField('newpwdconfirm');
                            this.setErrorLine(MyApp.oLocale.passwordChange.error.empty);
                            return false;
                        }
                        else {
                            if (pass + "" != passconfirm + "") {
                                this.updateUIBadField('newpwdconfirm');
                                this.setErrorLine(MyApp.oLocale.passwordChange.error.missmatch);
                                return false;
                            }
                            else {
                                //Regex are server sides
                                this.updateUIOKOldpass();
                                this.updateUIOkNPass();
                                this.updateUIOkNPassConfirm();

                                //success
                                return true;
                            }
                        }
                    }
                },
                updateUIOKOldpass: function () {
                    this.updateUIOkField('oldpwd');
                    this.setErrorLine('');
                },
                updateUIOkNPass: function () {
                    this.updateUIOkField('newpwd');
                    this.setErrorLine('');

                },
                updateUIOkNPassConfirm: function () {
                    this.updateUIOkField('newpwdconfirm');
                    this.setErrorLine('');

                },
                updateUIOkField: function (fieldId) {
                    $('#' + fieldId).removeClass('error');
                    $('label[for="' + fieldId + '"]').removeClass('error');
                },
                updateUIBadField: function (fieldId) {
                    //$('#'+fieldId).addClass('error');
                    $('label[for="' + fieldId + '"]').addClass('error');
                },
                setErrorLine: function (text) {
                    if (text && text != '') {
                        $("#errorLine").text(text);
                        $("#errorLine").show();
                    }
                    else {
                        $("#errorLine").text('');
                        $("#errorLine").hide();
                    }

                },
                openPopup: function (element_id, text) {
                    $('body').css('overflow', 'hidden');
                    if (text != '') {
                        $(element_id + ' div p').text(text);
                        $(element_id).popup();
                        $(element_id).popup('open');
                    }
                },
                saveNewPassword: function (login, oldpassword, newpassword) {
                    var self = this;
                    var myAppObject = MyApp;

                    pamHelper.sendRestRequest({
                        url: 'authpam/Authentification/CheckPwdModif/',
                        type: 'POST',
                        data: JSON.stringify({ UserEmail: login, QuestionId: "", Answer: "", OldValue: oldpassword, NewValue: newpassword, ConfirmNewValue: newpassword, ActionType: "CHANGEMENT_MP", BrandCode: MyApp.oConfig.marque() }),
                        success: function (data) {
                            if (data.CodeRetour == "" && data.LibelleRetour == "") {
                                //BEWARE
                                $.mobile.hidePageLoadingMsg();
                                self.nextPage('secretQuestion', [login, 'checkchangepwd', oldpassword, newpassword, "null"]);
                                //empécher l'auth silencieuse ?
                            }
                            else {
                                //ERROR
                                $.mobile.hidePageLoadingMsg();
                                self.openPopup('#Errordialog', myAppObject.oLocale.common.error);
                            }
                        }
                    });
                },
                closePopup: function () {
                    $('body').css('overflow', 'auto');
                    $('#dialog').popup('close');
                    // $.mobile.showPageLoadingMsg("b");

                },
                closePopupError: function () {
                    $('body').css('overflow', 'auto');
                    $('#Errordialog').popup('close');
                },
                updateUIBadField: function (fieldId) {
                    //$('#'+fieldId).addClass('error');
                    $('label[for="' + fieldId + '"]').addClass('error');
                },
                nextPage: function (viewName, params) {
                    try {
                        var paramToStr = "";
                        for (var i = 0; i < params.length; i++)
                            paramToStr += '/' + params[i];


                        Backbone.history.navigate(viewName + paramToStr, true);


                    } catch (e) {
                        this.setErrorLine(e);
                    }
                },
                openPopup: function (element_id, text) {
                    $('body').css('overflow', 'hidden');
                    if (text != '') {
                        $(element_id + ' div p').text(text);
                        $(element_id).popup();
                        $(element_id).popup('open');
                    }
                },
            });

            return view;
        });
