define(['jquery', 'underscore', 'backbone', 'pamhelper', 'md5', 'text!templates/checkUserEmail.html', 'text!templates/commons/header.html', 'text!templates/commons/footer.html', 'text!templates/auth/auth_dialog.html'],
    function ($, _, Backbone, pamHelper, MD5, tmpUserMail, tmpHeader, tmpFooter, tmpDialog) {
    var view = Backbone.View.extend({
        transition: 'fade',
        name:'checkUserEmail',
        events: {
            "click #HeaderReturnButton": "goBack",
            "click #ValidateEmail": "validateEmail",
            "click #closebtn": "closePopup",
            "click #ErrorClosebtn": "closePopupError",
        },
        decode: function (error) {
            return error.replace('%20', ' ').replace('%C3%A9', 'é').replace('%C3%8A', 'Ê');
        },
        initialize: function (options) {
            console.log("Initialisation Vue ".concat(this.name));
            _.bindAll(this, 'nextPage');
            _.bindAll(this, 'render');
            this.render();
            if (options) {
                console.log(options.email);
                var email = options.email;
                $('#email').val(email);
            }
            console.log("Sortie Initialisation Vue ".concat(this.name));
            //if (MyApp.oSessionManager.getLogin() && MyApp.oSessionManager.getLogin().trim() != "") {

            //}

        },
        goBack: function () {
            window.history.back();
        },
        showMessage: function () {
            if (MyApp.oSessionManager.getErrorMessageToDisplay() != undefined) {
                MyApp.openPopup("#Errordialog", MyApp.oSessionManager.getErrorMessageToDisplay());
                MyApp.oSessionManager.clearErrorMessageToDisplay();
            }
            if (this.message != undefined) {
                if (this.message == MyApp.oLocale.auth.disconnected || this.message == MyApp.oLocale.common.error.serverError) {
                    this.openPopup('#Errordialog', this.message);
                }
                else {
                    this.setErrorLine(this.message);
                }
            }
        },
        render: function () {
            console.log("Rendu Vue ".concat(this.name));
            $.mobile.hidePageLoadingMsg();
            $(this.el).append(_.template(tmpUserMail, { headerTemplate: _.template(tmpHeader), footerTemplate: _.template(tmpFooter), authDialog: _.template(tmpDialog) }));
            $('body').append($(this.el));
            $.mobile.changePage($(this.el), {
                changeHash: false,
                transition: 'none'
            });
            // pamHelper.showNbUnreadMissionsBadge(this.el);
            console.log("Sortie Rendu Vue ".concat(this.name));

            return this.el;

        },

        validateEmail: function () {

            var email = $('#email').val();

            //SHAMELESS
            // if (email == "validationapple@gmail.com") {
            //     MyApp.oConfig.serverAddress = function () {
            //         return 'https://recette.api-mobilite.grouperandstad.fr';
            //     }
            // }

            if (this.checkUserEmail(email)) {
                //AJAX !
                var self = this;
                var myAppObject = MyApp;
                console.log('auth with push token : ' + JSON.stringify(MyApp.oSessionManager.getDeviceToken()));
                pamHelper.sendRestRequest({
                    url: 'authpam/Authentification/CheckUserEmail',
                    type: 'POST',
                    data: JSON.stringify({ Identifiant: email, MotDePasse: "", ConfirmMotDePasse: "", DeviceID: MyApp.oSessionManager.getDeviceToken(), DeviceName: MyApp.oConfig.deviceName(), VersionAppli: MyApp.oConfig.appVersion(), CodeMarque: MyApp.oConfig.marque(), DeviceFamily: MyApp.oConfig.deviceFamily() }),
                    success: function (data) {
                        $.mobile.hidePageLoadingMsg();

                        //CHECK DATA PROP
                        if (data.LibelleRetour == "") {
                            self.sucessCheckingEmail(email);
                        }
                        else {
                            errorMessage = JSON.parse(data.LibelleRetour);
                            self.openPopup('#Errordialog', errorMessage.LibelleRetour);
                        }

                    }
                });

            }
            else {
                this.updateUIBadEmail();
            }
        },

        checkUserEmail: function (email) {
            var re = /\S+@\S+\.\S+/;
            return re.test(email);
        },
        updateUIBadEmail: function () {
            this.updateUIBadField('email');
            this.setErrorLine(MyApp.oLocale.auth.error.badEmail);
        },
        updateUIBadField: function (fieldId) {
            //$('#'+fieldId).addClass('error');
            $('label[for="' + fieldId + '"]').addClass('error');
        },
        setErrorLine: function (text) {
            if (text && text != '') {
                $("#errorLine").text(text);
                $("#errorLine").show();
            }
            else {
                $("#errorLine").text('');
                $("#errorLine").hide();
            }
        },
        updateUIOkEmail: function () {
            this.updateUIOkField('email');
            this.setErrorLine('');
        },
        updateUIOkPassword: function () {
            this.updateUIOkField('pwd');
            this.setErrorLine('');

        },
        updateUIOkField: function (fieldId) {
            $('#' + fieldId).removeClass('error');
            $('label[for="' + fieldId + '"]').removeClass('error');
        },
        openPopup: function (element_id, text) {
            $('body').css('overflow', 'hidden');
            if (text != '') {
                $(element_id + ' div p').text(text);
                $(element_id).popup();
                $(element_id).popup('open');
            }
        },
        closePopup: function () {
            $('body').css('overflow', 'auto');
            $('#dialog').popup('close');
            $.mobile.showPageLoadingMsg("b");
            if (MyApp.oSessionManager.isConnected())
                this.nextPage()
        },
        closePopupError: function () {
            $('body').css('overflow', 'auto');
            $('#Errordialog').popup('close');
        },
        nextPage: function (viewName, param) {
            var paramStr = '';
            for (var j = 0; j < param.length; j++)
                paramStr += '/' + param[j]
            if (paramStr == '')
                var nextPage = viewName;
            else
                var nextPage = viewName + '' + paramStr;
            Backbone.history.navigate(nextPage, true);
        },

        sucessCheckingEmail: function (email) {
            $.mobile.hidePageLoadingMsg();
            console.log(email);
            this.nextPage('secretQuestion', [email, 'check', "null", "null", "null"]);

        }

    });

    return view;
});
