define(['jquery', 'underscore', 'backbone', 'pamhelper','generic' , 'text!templates/contact.html', 'text!templates/commons/header.html', 'text!templates/commons/footer.html','models/ContactModel', 'text!templates/auth/auth_dialog.html'],
		function($, _, Backbone, pamHelper, GenericView, tmpContact, tmpHeader, tmpFooter, contactModel, tmpDialog) {
	var view = GenericView.extend({
		transition: 'fade',
		name:'contact',
		error: undefined,
		events: {
			'change #ContactSmsCheckBox' : 'modifierPreferencesContact',
			'change #ContactEmailCheckBox' : 'modifierPreferencesContact',
			'change #ContactPushCheckBox' : 'modifierPreferencesContact'
		},
		initialize : function() {
			console.log("Initialisation Vue ".concat(this.name));
			this.events = _.extend({}, this.genericEvents, this.events);
		    this.delegateEvents();
		    $.mobile.showPageLoadingMsg("b");
			_.bindAll(this, 'render');
			_.bindAll(this, 'renderData');
			this.model = new contactModel;
			this.model.bind('change', this.renderData);
			this.model.initialise();
			console.log("Sortie Initialisation Vue ".concat(this.name));
		},
		render : function() {
			console.log("Rendu Vue ".concat(this.name));
			$(this.el).append(_.template(tmpContact, { contact: this.model, headerTemplate: _.template(tmpHeader), footerTemplate: _.template(tmpFooter),authDialog : _.template(tmpDialog) }));
			
			var myAppObject = MyApp;
			$(this.el).live('pageshow',function(event, ui){
				if(myAppObject.oSessionManager.getErrorMessageToDisplay() != undefined){
					myAppObject.openPopup("#dialog",myAppObject.oSessionManager.getErrorMessageToDisplay());
				}
			});
			pamHelper.showNbUnreadMissionsBadge(this.el);
			
			$.mobile.hidePageLoadingMsg();
			console.log("Sortie Rendu Vue ".concat(this.name));
			return this.el;
		},
		modifierPreferencesContact : function(){
			console.log('modifierPreferencesContact');
			var contactSms = $('#ContactSmsCheckBox').is(":checked");
			var contactEmail = $('#ContactEmailCheckBox').is(":checked");
			var contactPush = $('#ContactPushCheckBox').is(":checked"); 
			this.model.modifierPreferencesContact(contactSms,contactEmail,contactPush);
		}
	});

	return view;
});
