define(['jquery', 'underscore', 'backbone', 'pamhelper', 'md5', 'text!templates/customPwd.html', 'text!templates/commons/header.html', 'text!templates/commons/footer.html', 'text!templates/auth/auth_dialog.html'],
 function ($, _, Backbone, pamHelper, MD5, tmpAuth, tmpHeader, tmpFooter, tmpDialog) {
    var view = Backbone.View.extend({
        transition: 'fade',
        name:'CustomPassword',
        events: {
            "click #ConfirmCustom": "confirmCustom",
            "click #closebtn": "closePopup",
            "click #ErrorClosebtn": "closePopupError",
        },
        decode: function (error) {
            return error.replace('%20', ' ').replace('%C3%A9', 'é').replace('%C3%8A', 'Ê');
        },
        initialize: function (options) {
            console.log("Initialisation Vue ".concat(this.name));
            //_.bindAll(this, 'nextPage');
            _.bindAll(this, 'render');
            this.render();

            if (options && options.email) {
                this.email = options.email;
            }
            console.log("Sortie Initialisation Vue ".concat(this.name));
        },
        showMessage: function () {
            if (MyApp.oSessionManager.getErrorMessageToDisplay() != undefined) {
                MyApp.openPopup("#Errordialog", MyApp.oSessionManager.getErrorMessageToDisplay());
                MyApp.oSessionManager.clearErrorMessageToDisplay();
            }
            if (this.message != undefined) {
                if (this.message == MyApp.oLocale.auth.disconnected || this.message == MyApp.oLocale.common.error.serverError) {
                    this.openPopup('#Errordialog', this.message);
                }
                else {
                    this.setErrorLine(this.message);
                }
            }
        },
        render: function () {
            console.log("Rendu Vue ".concat(this.name));

            $(this.el).append(_.template(tmpAuth, { headerTemplate: _.template(tmpHeader), footerTemplate: _.template(tmpFooter), authDialog: _.template(tmpDialog) }));
            $('body').append($(this.el));
            $.mobile.changePage($(this.el), {
                changeHash: false,
                transition: 'none'
            });
            pamHelper.showNbUnreadMissionsBadge(this.el);
            $.mobile.hidePageLoadingMsg();

            console.log("Sortie Rendu Vue ".concat(this.name));
            return this.el;

        },
        confirmCustom: function () {

            //Check values
            if (this.checkPasswords($('#newpwd').val(), $('#newpwdConfirm').val())) {
                //getEmail
                //Call to saveNewPassword
                this.saveNewPassword(this.email, $('#newpwd').val(), $('#newpwdConfirm').val());
            }
            else {
                // Error was trapped in checkPasswords
            }
        },
        checkPasswords: function (pass, passconfirm) {
            if (!pass && !passconfirm) {
                this.updateUIBadField('newpwd');
                this.updateUIBadField('newpwdConfirm');
                this.setErrorLine(MyApp.oLocale.passwordChange.error.empty);
                return false;
            }
            else {
                if ((pass && pass.trim() == "") || (passconfirm && passconfirm.trim() == "")) {
                    this.updateUIBadField('newpwd');
                    this.updateUIBadField('newpwdConfirm');
                    this.setErrorLine(MyApp.oLocale.passwordChange.error.empty);
                    return false;
                }
                else {
                    if (pass != passconfirm) {
                        this.updateUIBadField('newpwdConfirm');
                        this.setErrorLine(MyApp.oLocale.passwordChange.error.missmatch);
                        return false;
                    }
                    else {
                        //Regex are server sides
                        //success
                        this.updateUIOKField('newpwd');
                        this.updateUIOKField('newpwdConfirm');
                        return true;
                    }
                }
            }
        },
        updateUIOKField: function (fieldId) {
            //$('#'+fieldId).addClass('error');
            $('label[for="' + fieldId + '"]').removeClass('error');
        },
        updateUIBadField: function (fieldId) {
            //$('#'+fieldId).addClass('error');
            $('label[for="' + fieldId + '"]').addClass('error');
        },
        setErrorLine: function (text) {
            if (text && text != '') {
                $("#errorLine").text(text);
                $("#errorLine").show();
            }
            else {
                $("#errorLine").text('');
                $("#errorLine").hide();
            }
        },
        openPopup: function (element_id, text) {
            $('body').css('overflow', 'hidden');
            if (text != '') {
                $(element_id + ' div p').text(text);
                $(element_id).popup();
                $(element_id).popup('open');
            }
        },
        saveNewPassword: function (login, password, passwordconfirm) {
            var self = this;
            var myAppObject = MyApp;
            pamHelper.sendRestRequest({
                url: '/authpam/Authentification/CustomPassword/',
                type: 'POST',
                data: JSON.stringify({ Identifiant: login, MotDePasse: password, ConfirmMotDePasse: passwordconfirm, DeviceID: MyApp.oSessionManager.getDeviceToken(), DeviceName: MyApp.oConfig.deviceName(), VersionAppli: MyApp.oConfig.appVersion(), CodeMarque: MyApp.oConfig.marque(), DeviceFamily: MyApp.oConfig.deviceFamily() }),
                success: function (data) {
                    // console.log(data);
                    if (data.CodeRetour == "" && data.LibelleRetour == "")
                        self.nextPage('secretQuestion', [login, 'select', "null", password, "null"]);
                    else {
                        //ERROR
                        self.openPopup('#Errordialog', data.LibelleRetour);
                    }
                }

            });
        },
        closePopup: function () {
            $('body').css('overflow', 'auto');
            $('#dialog').popup('close');

        },
        closePopupError: function () {
            $('body').css('overflow', 'auto');
            $('#Errordialog').popup('close');
        },
        nextPage: function (viewName, param) {
            try {
                var paramStr = '';
                for (var j = 0; j < param.length; j++)
                    paramStr += '/' + param[j]
                if (paramStr == '')
                    var nextPage = viewName;
                else
                    var nextPage = viewName + '' + paramStr;
                Backbone.history.navigate(nextPage, true);

            } catch (e) {
                this.setErrorLine(e);
            }
        },
        sucessCustom: function (email, password, memorize, data) {

        }

    });

    return view;
});
