define(['jquery', 'underscore', 'backbone', 'pamhelper','generic' ,
        'text!templates/enCours.html', 'text!templates/commons/header.html', 'text!templates/commons/footer.html',
        'views/enCours/enCoursList', 'text!templates/auth/auth_dialog.html'],
        function($, _, Backbone, pamHelper, GenericView, tmpEnCours, tmpHeader, tmpFooter, enCoursListView,tmpDialog) {
	
	
	var view = GenericView.extend({
		events: {
		},
		transition: 'fade',
		error: undefined,
		name:'enCours',
		initialize : function(options) {
			console.log("Initialisation Vue ".concat(this.name));
			var me = this;
			this.events = _.extend({}, this.genericEvents, this.events);
			_.bindAll(this, 'render');
			_.bindAll(this, 'renderData');
		    this.delegateEvents();
			
		    //Redirection dans le cas d'une seule mission
		    MyApp.oMissionManager.getMissions(function(missions){
		    	var currentMissions = missions.GetCurrentOffers();
		    	if(currentMissions.length==1 && options.message == undefined){
			    	me.onlyOneOffer(currentMissions);
			    };
		    });

		    if (options){
				this.error= options.message;
			}
			console.log("Sortie Initialisation Vue ".concat(this.name));
		},
		render : function() {
			console.log("Rendu Vue ".concat(this.name));
			//Adding underscore compliant templates for footer and header
			$(this.el).append(_.template(tmpEnCours,
					{ headerTemplate: _.template(tmpHeader), footerTemplate: _.template(tmpFooter),authDialog : _.template(tmpDialog), _: _}));		 
	
			var me = this;
			var myAppObject = MyApp;
			
			//Insertion de la vue liste des missions suivant le nombre de missions
			MyApp.oMissionManager.getMissions(function(missions) {
				var currentMissions = missions.GetCurrentOffers();
				$(me.el).find("#enCoursListView").html('');
				if(currentMissions.length <= 1){
					if(currentMissions.length == 0){
						$(me.el).find("#enCoursListView").html(MyApp.oLocale.mission.error.noMission);
					}
					$(me.el).find("#enCoursListView").removeClass('MissionsEnCoursContainer');
				} else {
					me.enCoursListView = new enCoursListView();
					
					$(me.el).find("#enCoursListView").addClass('MissionsEnCoursContainer');
					pamHelper.assign(me, {
						'#enCoursListView' : me.enCoursListView,
					});
				}
				pamHelper.showNbUnreadMissionsBadge(me.el, missions.GetCurrentUnreadOffersTag());				
			},function(data,errorMessage) {
				$(me.el).find("#enCoursListView").html(MyApp.oLocale.mission.error.server);
				$(me.el).find("#enCoursListView").removeClass('MissionsEnCoursContainer');
			});
			

			$(this.el).live('pageshow',function(event, ui){
				$(".MissionsEnCoursItemTitle").dotdotdot({wrap:'letter'});
				$(".MissionsEnCoursItem").dotdotdot();

				if(myAppObject.oSessionManager.getErrorMessageToDisplay() != undefined){
					myAppObject.openPopup("#dialog",myAppObject.oSessionManager.getErrorMessageToDisplay());
				}
				if(this.error != undefined){
					myAppObject.openPopup("#dialog",this.error);
				}
			});

			console.log("Sortie Rendu Vue ".concat(this.name));

			return this.el;
		},
		onlyOneOffer : function (missions){
			var synthesePage;
			synthesePage ='#enCoursSynthese/'+missions[0].get('Id');
			window.location.hash =	synthesePage;
		}
		
	});

	return view;
});
