define(['jquery', 'underscore', 'backbone', 'pamhelper','generic' , 'text!templates/enCoursDetails.html', 'text!templates/commons/headerSmall.html', 'text!templates/commons/footer.html',
        'models/DetailedOfferModel', 'text!templates/auth/auth_dialog.html'], 
        function($, _, Backbone, pamHelper, GenericView, tmpEnCoursDetails, tmpHeaderSmall, tmpFooter, detailedOfferModel,tmpDialog) {
	var view = GenericView.extend({
		events: {
			'click .EnCoursDetailsListeAnnexeItem': 'openLink'
		},
		name:'enCoursDetails',
		//transition: 'none',
		initialize : function(options) {
			console.log("Initialisation Vue ".concat(this.name));
			this.events = _.extend({}, this.genericEvents, this.events);
			this.delegateEvents();
			$.mobile.showPageLoadingMsg("b");
			_.bindAll(this, 'render');
			_.bindAll(this, 'renderData');
			
			this.model = new detailedOfferModel;
			this.model.bind('change', this.renderData);
			
			this.model.initialise(options);
			console.log("Sortie Initialisation Vue ".concat(this.name));
		},
		render : function() {
			console.log("Rendu Vue ".concat(this.name));
			// Si le nom de service n'est pas renseigné
			// On affichera le nom de l'entreprise dans l'acceptation partielle
			if(this.model.get('Service') == null || this.model.get('Service') == undefined || this.model.get('Service') == ""){
				var tableauDescriptif =  this.model.get('Descriptif');
				var entreprise = "";
				for(var i=0; i<tableauDescriptif.length; i++){
					if(tableauDescriptif[i].Libelle == "Entreprise"){
						entreprise = tableauDescriptif[i].Contenu;
					}
				}
				MyApp.oSessionManager.setCurrentMissionEntreprise(entreprise);
				MyApp.oSessionManager.setCurrentMissionSevice(null);
			}else{
				MyApp.oSessionManager.setCurrentMissionSevice(this.model.get('Service'));
				MyApp.oSessionManager.setCurrentMissionEntreprise(null);
			}
			
			//Adding underscore compliant templates for footer and header
			$(this.el).append(_.template(tmpEnCoursDetails, { offer: this.model, smallHeaderTemplate: _.template(tmpHeaderSmall), footerTemplate: _.template(tmpFooter),authDialog : _.template(tmpDialog) }));

			pamHelper.showNbUnreadMissionsBadge(this.el);

			$.mobile.hidePageLoadingMsg();
			
			console.log("Sortie Rendu Vue ".concat(this.name));
			return this.el;
		},
		dotdotdot : function(id){
			setTimeout(function(){
				$(".MissionsEnCoursItemDescription").dotdotdot();
				},100);
		},
		closePopup : function (){
			var path = window.location.pathname;
			window.history.replaceState({} , 'foo', path+"#enCoursSynthese");
			$('#dialog').popup('close');
		},
		openLink : function(source){
			if(cordova && cordova.InAppBrowser) {
				cordova.InAppBrowser.open(source.target.attributes['link'].nodeValue, '_system', 'location=no');
			}
			else {
				window.open(source.target.attributes['link'].nodeValue, '_blank', 'location=no')
			}
		}
		
	});

	return view;
});
