define(['jquery', 'underscore', 'backbone', 'pamhelper','generic' , 'text!templates/enCoursSynthese.html', 'text!templates/commons/header.html', 'text!templates/commons/footer.html',
        'models/SumOfferModel', 'text!templates/auth/auth_dialog.html'],
        function($, _, Backbone, pamHelper, GenericView, tmpEnCoursDetails, tmpHeader, tmpFooter, sumOfferModel,tmpDialog) {
	var view = GenericView.extend({
		//transition: 'none',
		
		transition: 'none',
		events: {
			"click #ImprevuButton" : "imprevu",
			"click .EnCoursSyntheseListeAnnexeItem" : "goToDetails"
		},
		name:'enCoursSynthese',
		initialize : function(options) {
			console.log("Initialisation Vue ".concat(this.name));
			
			var me = this;
			MyApp.oMissionManager.getMissions(function(missions){
				me.transition = (missions.GetCurrentOffers()==1? 'slide':'none');
			});
			
			this.events = _.extend({}, this.genericEvents, this.events);
			this.delegateEvents();
			$.mobile.showPageLoadingMsg("b");
			_.bindAll(this, 'render');
			_.bindAll(this, 'renderData');
			this.model = new sumOfferModel;
			this.model.bind('change', this.renderData);
			this.model.initialise(options);
			console.log("Sortie Initialisation Vue ".concat(this.name));
		},
		render : function() {
			console.log("Rendu Vue ".concat(this.name));
			
			if(this.model.get('Service') == null || this.model.get('Service') == undefined || this.model.get('Service') == ""){
				var synthese =  this.model.get('SyntheseContenu');
				// select the enterprise name in the html content
				var entRegExp = /(?:Entreprise : <\/strong>((?:[^<])*))/i;
				var entreprise = entRegExp.exec(synthese)[1];
				if(entreprise != null){
					MyApp.oSessionManager.setCurrentMissionEntreprise(entRegExp.exec(synthese)[1]);
				}
				else{
					MyApp.oSessionManager.setCurrentMissionEntreprise('');
				}
				MyApp.oSessionManager.setCurrentMissionSevice(null);
			}else{
				MyApp.oSessionManager.setCurrentMissionSevice(this.model.get('Service'));
				MyApp.oSessionManager.setCurrentMissionEntreprise(null);
			}
			
			MyApp.oSessionManager.setCurrentMissionSevice(this.model.get('Service'));

			$(this.el).html(_.template(tmpEnCoursDetails, { offer: this.model, headerTemplate: _.template(tmpHeader), footerTemplate: _.template(tmpFooter),authDialog : _.template(tmpDialog) }));
			
			
			var me = this;
			MyApp.oMissionManager.getMissions(function(missions){
				
				var currentMissions = missions.GetCurrentOffers();
				//Affichage ou non d'un bouton de retour dans le header
				var divBack = $(me.el).find("#HeaderReturnButton");
				if(divBack) {
				 	if(currentMissions.length > 1) {
						divBack.addClass('headerReturnButton');
						divBack.attr('data-rel','back');
					}
				} else {
						divBack.removeClass('headerReturnButton');
						divBack.removeAttr('data-rel');
				}
				pamHelper.showNbUnreadMissionsBadge(me.el,missions.GetCurrentUnreadOffersTag());
			});





			$.mobile.hidePageLoadingMsg();

			console.log("Sortie Rendu Vue ".concat(this.name));
			return this.el;
		},
		goToDetails : function(source) {
			if(source.currentTarget.id.substring(0, 8) == "planning"){
				Backbone.history.navigate('/acceptationPlanning/' + this.model.attributes.Id + '/readOnlyEnCours', true);
			}
			else {
				Backbone.history.navigate('/enCoursDetails/' + source.currentTarget.id, true);
			}
		},
		goBack : function() {
			MyApp.reversePage = true;
			Backbone.history.navigate('/enCours' , true);
		},
		imprevu : function() {
			Backbone.history.navigate('/enCoursImprevu/' + this.model.attributes.Id , true);
		}
	});

	return view;
});
