define(['jquery', 'underscore', 'backbone', 'pamhelper'],
        function($, _, Backbone, pamHelper) {
	Backbone.View.prototype.close = function(){
		 if (this.remove)
		  this.remove(); 
		  if (this.unbind)
		  this.unbind();
		  if (this.onClose){
		    this.onClose();
		  }
		}
	var view = Backbone.View.extend({
		genericEvents: {
			"click #HeaderReturnButton" : "goBack",
			"click #HeaderLogoutButton": "openLogoutPopup",
			"click #ChangeEmail": "redirectToChangeEmail",
			"click #ChangePassword": "redirectToChangePassword",
			"click #closebtn" 	: "closePopup",
			"click #okbtn" 	: "closeAndLogoutPopup",
			"click #nobtn" 	: "closeLogoutPopup",
			"click #refusokbtn" 	: "refusAndClosePopup",
			"click #refusnobtn" 	: "closeRefusPopup",
			"tap .FooterLink" : "activateFooterLink"
		},
		name:'generic',
		goBack : function() {
			MyApp.reversePage = true;
			window.history.back();
		},
		
		closeAndLogoutPopup : function (){
			MyApp.closeLogoutPopup();
			pamHelper.sendRestRequest({
				url:  'Deconnexion',
				type: 'POST',
				success:function(data) {
					pamHelper.logout(true);
				}
			});
			
		},
		closeLogoutPopup : function (){
		    $('body').css('overflow', 'auto');
			MyApp.closeLogoutPopup();
		},
		closePopup : function (){
			MyApp.oSessionManager.clearErrorMessageToDisplay();
		    $('body').css('overflow', 'auto');
		},
		openLogoutPopup : function (){ 
			$('body').css('overflow', 'hidden');
			MyApp.openLogoutPopup();
		},
		redirectToChangeEmail : function(){
		    if(MyApp.oSessionManager.isConnected() && MyApp.oSessionManager.getLogin() != "") {
		        Backbone.history.navigate('changeEmail', true); ///' + MyApp.oSessionManager.getLogin()
		    }
		},
		redirectToChangePassword: function () {
		    if (MyApp.oSessionManager.isConnected() && MyApp.oSessionManager.getLogin() != "") {
		        Backbone.history.navigate('changePassword', true);///' + MyApp.oSessionManager.getLogin()
		    }
		},
		onClose: function(){
			if(this.model)
		    this.model.unbind("change", this.render);
		},
		renderData : function(){
			MyApp.Router.changePage(this,$(this.el).attr('id'));
			this.dotdotdot();
			//if(this.error != undefined){
			if(MyApp.oSessionManager.getErrorMessageToDisplay() != undefined){
				MyApp.openPopup("#dialog",MyApp.oSessionManager.getErrorMessageToDisplay());
			}
		},
		dotdotdot : function(){
			console.log('not dotdotdot');
		},
		openConfirmationRefuse: function(){
			$('body').css('overflow', 'hidden');
			MyApp.openPopup('#dialogRefus');
		},
		closeRefusPopup: function(){
			$('#dialogRefus').popup('close');	
		},
		activateFooterLink: function(event){
			$(".FooterLink").removeClass("FooterItemActive");
			$(event.target).closest(".FooterLink").addClass("FooterItemActive");
		},
		refusAndClosePopup: function(){
		}
	});
	return view;
});