define(['jquery', 'underscore', 'backbone', 'mobiscrollDateTimeFr', 'pamhelper', 'generic', 'text!templates/indisponibilites.html', 'text!templates/commons/header.html', 'text!templates/commons/footer.html',
        'models/IndisponibilitesModel','text!templates/indisponibilites/indisponibilitesList.html', 'text!templates/auth/auth_dialog.html', 'dateHelper'],
        function($, _, Backbone, Mobiscroll, pamHelper, GenericView, tmpIndisponibilites, tmpHeader, tmpFooter, indisponibilitesModel, tmpIndisponibilitesListView, tmpDialog, DateHelper) {
	var view = GenericView.extend({
		transition: 'fade',
		error: undefined,
		name:'indisponibilites',
		events: {
			"click #AjouterIndisponibiliteButton" : "ajouterIndisponibilite",
			'click #AjoutIndisponibiliteOKbtn' : 'ajouterIndisponibilitePopupOK',
			'click #AjoutIndisponibiliteCancelbtn' : 'ajouterIndisponibilitePopupCancel',
			"click .IndisponibilitesSuppressionButton" : "supprimerIndisponibilite",
			'click #SuppressionIndisponibiliteOKbtn' : 'supprimerIndisponibilitePopupOK',
			'click #SuppressionIndisponibiliteCancelbtn' : 'supprimerIndisponibilitePopupCancel',
			'click #ErrordialogOKbtn' : 'closeErrorPopup',
		},
		initialize : function(options) {
			console.log("Initialisation Vue ".concat(this.name));
			this.events = _.extend({}, this.genericEvents, this.events);
			this.delegateEvents();
			$.mobile.showPageLoadingMsg("b");
			_.bindAll(this, 'render');
			_.bindAll(this, 'updateIndisponibilitesList');
			this.model = new indisponibilitesModel;
			//this.model.initialise();
			this.model.bind('change', this.updateIndisponibilitesList);
			if(options.dateDebutMissionRefusee != undefined && options.dateDebutMissionRefusee != ""){
				this.renderData();
			}
			console.log("Sortie Initialisation Vue ".concat(this.name));
		},
		render : function() {
			console.log("Rendu Vue ".concat(this.name));
			var thisObject = this;
			$(this.el).html(_.template(tmpIndisponibilites, { indisponibilites: this.model, headerTemplate: _.template(tmpHeader), footerTemplate: _.template(tmpFooter), indisponibilitesList : _.template(tmpIndisponibilitesListView), authDialog : _.template(tmpDialog) }));
			$.mobile.hidePageLoadingMsg();
			console.log(this.el);
			var myAppObject = MyApp;
			//// Configuration du datePicker mobiscroll 
			$(this.el).live('pageshow',function(event, ui){
				if(myAppObject.oSessionManager.getErrorMessageToDisplay() != undefined){
					myAppObject.openPopup("#dialog",myAppObject.oSessionManager.getErrorMessageToDisplay());
				}

				var today = new Date(); 
				var limit = new Date(today.getFullYear() + 20, 1 ,1);
				maxDate = new Date().setDate(36500);
				$('.datePicker').mobiscroll().date({
					theme: 'sense-ui',
					lang: 'fr',
				    dateOrder: 'ddmmyy',
					dateFormat: 'dd/mm/yy',
					maxDate : limit,
					animate : 'fade'
				});
				
			    $('.datePicker').click(function(){
			        $('.datePicker').mobiscroll('show'); 
			        return false;
			    });
			    
			    $('.datePicker').click(function () {
			        $('.datePicker').val('');
			        return false;
			    });
			    
				if (thisObject.options.dateDebutMissionRefusee != undefined){
					//// on remplace les '-' de la date par des '/'
					$("#dateDebutAjout").val(new DateHelper().getDateForDisponibiliteFilling(thisObject.options.dateDebutMissionRefusee));
				}

				//// Model
				thisObject.updateIndisponibilitesList();
			});
			
			pamHelper.showNbUnreadMissionsBadge(this.el);

			console.log("Sortie Rendu Vue ".concat(this.name));
			return this.el;
		},
		updateIndisponibilitesList : function() {
			this.model.initialise();
			$('#IndisponibilitesListView').empty();
			if(this.model.attributes.Indisponibilites !=undefined && this.model.attributes.Indisponibilites.length>0){
				$('.IndisponibilitesList').show();
				
			}else{
				$('.IndisponibilitesList').hide();
				
			}
			$('#IndisponibilitesListView').append(_.template(tmpIndisponibilitesListView, { indisponibilites: this.model.attributes}));
			// hiding the loader that was eventually displayed
			$.mobile.loading( 'hide' );	
		},
		ajouterIndisponibilite : function(){
			console.log('ajouterIndisponibilite');
			var DateHelperObject = new DateHelper();
			this.dateDebutAjout = $('#dateDebutAjout').val();
			this.dateFinAjout = $('#dateFinAjout').val();
			
			this.dateFin = DateHelperObject.parseDateFullYear(this.dateFinAjout)
			this.dateDebut = DateHelperObject.parseDateFullYear(this.dateDebutAjout);
			
			if(this.dateDebutAjout != undefined && this.dateFinAjout != undefined &&
					this.dateDebutAjout != "" && this.dateFinAjout != "" ){
				if(this.dateDebut > this.dateFin){
					MyApp.openPopup("#dialog","La date de début est ultérieure à la date de fin");
				}else{
					$('body').css('overflow', 'hidden');
					$('#dateDebutAjoutPopUp').html(this.dateDebutAjout);
					$('#dateFinAjoutPopUp').html(this.dateFinAjout);
					$('#AjoutIndisponibilitedialog').popup('open');
				}
			}else{
				MyApp.openPopup("#dialog","Les dates d'indisponibilité n'ont pas été correctement saisies");
			}
		},
		ajouterIndisponibilitePopupOK : function() {
			$('body').css('overflow', 'auto');
			$('#AjoutIndisponibilitedialog').popup('close');
			this.ajouterIndisponibiliteConfirmation();
		},
		ajouterIndisponibilitePopupCancel: function() {
			$('body').css('overflow', 'auto');
			$('#AjoutIndisponibilitedialog').popup('close');
		},
		ajouterIndisponibiliteConfirmation : function(){
			console.log('ajouterIndisponibiliteConfirmation');
			var thisObjectAjouter=this;
			var myAppObject = MyApp;
			this.model.ajouter(this.dateDebut, this.dateFin,
				function(data){
					$.mobile.hidePageLoadingMsg();
					myAppObject.oSessionManager.clearCacheValue("indisponibilites");
					$('#dateDebutAjout').val("");
					$('#dateFinAjout').val("");
					thisObjectAjouter.updateIndisponibilitesList();
				},function(data){
					myAppObject.oSessionManager.clearCacheValue("indisponibilites");
					$.mobile.hidePageLoadingMsg();
				 	errorMessage = data;
				 	if (data.CodeErreur == 90 || data.CodeErreur == 91){
				 		$('body').css('overflow', 'hidden');
						$('#Errordialog').popup('open');
						$('#IndisponibilitesErrorTitle').text("Erreur lors de l'ajout de l'indisponibilité");
						$('#IndisponibilitesErrorMessage').text(data.LibelleErreur.FR);
				 	}
				 	else{
				 		myAppObject.openPopup('#dialog', errorMessage);
				 	}
				}
			);
		},
		supprimerIndisponibilite : function(source){
			console.log('supprimerIndisponibilite');
			var cellArgs = source.target.id.split('_');
			console.log(cellArgs[1]);
			this.IdIndisponibiliteASupprimer=cellArgs[1];
			$('body').css('overflow', 'hidden');
			$('#SuppressionIndisponibilitedialog').popup('open');;
		},
		supprimerIndisponibilitePopupOK : function() {
			$('body').css('overflow', 'auto');
			$('#SuppressionIndisponibilitedialog').popup('close');
			this.supprimerIndisponibiliteConfirmation();
		},
		supprimerIndisponibilitePopupCancel: function() {
			$('body').css('overflow', 'auto');
			$('#SuppressionIndisponibilitedialog').popup('close');
		},
		supprimerIndisponibiliteConfirmation : function(){
			console.log('supprimerIndisponibiliteConfirmation');
			var thisObjectSupprimer=this;
			var myAppObject = MyApp;
			this.model.supprimer(this.IdIndisponibiliteASupprimer,
				function(data){
					$.mobile.hidePageLoadingMsg();
					myAppObject.oSessionManager.clearCacheValue("indisponibilites");
					thisObjectSupprimer.updateIndisponibilitesList();
				},function(data){
					myAppObject.oSessionManager.clearCacheValue("indisponibilites");
					$.mobile.hidePageLoadingMsg();
				 	errorMessage = data;
				 	console.log(errorMessage);
				 	if(data.CodeErreur == 1 || data.CodeErreur == 2){
				 		window.location.hash = '#auth/'+data.LibelleErreur.FR;
				 		return;
				 	}
				 	else if (data.CodeErreur == 100 || data.CodeErreur == 101){
				 		$('body').css('overflow', 'hidden');
						$('#Errordialog').popup('open');
						$('#IndisponibilitesErrorTitle').text("Erreur lors de la suppression de l'indisponibilité");
						$('#IndisponibilitesErrorMessage').text(data.LibelleErreur.FR);
				 	}
				 	else{
				 		myAppObject.openPopup('#dialog', errorMessage);
				 	}
				}
			);
		},
		closeErrorPopup : function() {
			$('body').css('overflow', 'auto');
			$('#Errordialog').popup('close');
		}
	});

	return view;
});
