define(['jquery', 'underscore', 'backbone', 'swipejs', 'moment', 'pamhelper','generic' , 'dateHelper',
        'text!templates/planning.html', 'text!templates/commons/headerSmall.html', 'text!templates/commons/footer.html', 'text!templates/planning/planningTables.html',
        'models/AvailabilityModel', 'text!templates/auth/auth_dialog.html'], function($, _, Backbone, Swipejs, Moment, pamHelper, GenericView, DateHelper, tmpPlanning, tmpHeaderSmall, tmpFooter, tmpPlanningTables, availabilityModel,tmpDialog) {
	var view = GenericView.extend({
		name:'planning',
		events: {
			'click #PlanningValidateButton' : 'validate',
			'click #previousButton' : 'goPreviousWeek',
			'click #nextButton' : 'goNextWeek',
			'click #SendPlanningOKbtn' : 'planningPopupOK',
			'click #SendPlanningCancelbtn' : 'planningPopupCancel',
			'click .SelectableCell' : 'changeCellState',
			'click #ErrordialogOKbtn' : 'closeErrorPopup',
			'click .FooterContainer' : 'checkIfNotUnsavedChanges',
			'tap .FooterLink' : 'checkIfNotUnsavedChangesActivation',
			'click #NonSavedChangesOKbtn' : 'NotCommitedDialogOKHandler',
			'click #ErrorMissiondialog' : 'ErrorMissiondialogOKHandler',
			'click #NonSavedChangesCancelbtn' : 'NotCommitedDialogCancelHandler'
		},
		transition: 'fade',
		initialize : function() {
			console.log("Initialisation Vue ".concat(this.name));
			moment.lang('fr', {months : "janvier_février_mars_avril_mai_juin_juillet_août_septembre_octobre_novembre_décembre".split("_")});
			this.events = _.extend({}, this.genericEvents, this.events);
			this.delegateEvents();
			$.mobile.showPageLoadingMsg("b");
			_.bindAll(this, 'render');
			_.bindAll(this, 'slideChanged');
			_.bindAll(this, 'updatePlanning');
			_.bindAll(this, 'initializeSwipe');
			_.bindAll(this, 'loadWeek');
			_.bindAll(this, 'openPopup');
			_.bindAll(this, 'planningPopupOK');
			_.bindAll(this, 'swipePreviousWeek');
			_.bindAll(this, 'swipeNextWeek');
			_.bindAll(this, 'goToMission');
			_.bindAll(this, 'changeCellState');
			_.bindAll(this, 'checkIfNotUnsavedChanges');
			_.bindAll(this, 'checkIfNotUnsavedChangesActivation');
			_.bindAll(this, 'NotCommitedDialogOKHandler');
			this.model = new availabilityModel(null, moment().isoWeekYear(), moment().isoWeek());
			this.model.setView(this);
			this.model.bind('change', this.updatePlanning);
			this.dodotdotConfiguration = {wrap:'letter'};
			console.log("Sortie Initialisation Vue ".concat(this.name));
		},
		render : function() {
			console.log("Rendu Vue ".concat(this.name));
			var planningModel = this.model != undefined ? this.model.attributes : undefined;
			$(this.el).append(_.template(tmpPlanning, { planning: planningModel, smallHeaderTemplate: _.template(tmpHeaderSmall), footerTemplate: _.template(tmpFooter),authDialog : _.template(tmpDialog), planningTables : _.template(tmpPlanningTables), getMomentDateFromISO: this.getMomentDateFromISO }));
			$(this.el).find('#PlanningSwipeWrap').append('<div class="PlanningslideContainer">');
			//$(this.el).find('#PlanningSwipeWrap').prepend('<div class="PlanningslideContainer">');
			$.mobile.hidePageLoadingMsg();
			var thisObject = this;
			var indexNumber = this.index ? this.index : 1;
			var myAppObject = MyApp;
			$(this.el).live('pageshow',function(event, ui){
				thisObject.updatePlanning();
				if(myAppObject.oSessionManager.getErrorMessageToDisplay() != undefined){
					myAppObject.openPopup("#dialog",myAppObject.oSessionManager.getErrorMessageToDisplay());
				}
			});

			pamHelper.showNbUnreadMissionsBadge(this.el);

			console.log("Sortie Rendu Vue ".concat(this.name));
			return this.el;
		},
		// called when the model has been updated and updates the plannings
		updatePlanning : function() {
			if (this.swipe != undefined && this.swipe.kill != undefined)
				this.swipe.kill();
			$('#PlanningContainer').empty();
			$('#PlanningContainer').append(_.template(tmpPlanningTables, { model: this.model.attributes, partialPlanning : false, getMomentDateFromISO: this.getMomentDateFromISO}));
			$('#PlanningSwipeWrap').append('<div class="PlanningslideContainer">');
			$('#PlanningSwipeWrap').prepend('<div class="PlanningslideContainer">');
			var indexNumber = this.indexNumber != undefined ? this.indexNumber : 1;
			// hiding the loader that was eventually displayed
			$.mobile.loading( 'hide' );
			this.initializeSwipe(indexNumber);
		},
		initializeSwipe : function (indexNumber) {
			this.swipe = new Swipe(document.getElementById('PlanningWeeksContainer'), {
				callback: this.slideChanged,
				startSlide: indexNumber + ''
			});
			$(".PlanningSemaine" + (indexNumber - 2) + " .creneauMission").dotdotdot(this.dodotdotConfiguration);
			$(".PlanningSemaine" + (indexNumber - 1) + " .creneauMission").dotdotdot(this.dodotdotConfiguration);
			$(".PlanningSemaine" + (indexNumber) + " .creneauMission").dotdotdot(this.dodotdotConfiguration);
			this.SlideToCommit = indexNumber;
			if(this.model.attributes.Plannings != undefined){
				var weekDate = this.getMomentDateFromISO(this.model.attributes.Plannings[indexNumber - 1].Annee, this.model.attributes.Plannings[indexNumber - 1].Semaine, 1);
				$('#PlanningWeekHeaderText').text('S' + weekDate.isoWeek() + ' - ' + weekDate.format('MMMM') + ' ' + weekDate.isoWeekYear());
			}
			console.log('initializing swipe finished');
		},
		slideChanged : function(index, slide) {
			console.log('slide changed');
			console.log('index ' + index);
			console.log('user move ' + this.usermove);



			// Check if data should be loaded for the next/previous week
			if (index == 0) {
				this.loadPreviousWeek(this.model.attributes.Plannings[0].Annee, this.model.attributes.Plannings[0].Semaine);
			}
			else if (index == this.swipe.getNumSlides() - 1) {
				this.loadNextWeek(this.model.attributes.Plannings[index - 2].Annee, this.model.attributes.Plannings[index - 2].Semaine);
			}
			else {
				var weekDate = this.getMomentDateFromISO(this.model.attributes.Plannings[index - 1].Annee, this.model.attributes.Plannings[index - 1].Semaine, 1);
				$('#PlanningWeekHeaderText').text('S' + weekDate.isoWeek() + ' ' + weekDate.format('MMMM') + ' ' + weekDate.isoWeekYear());
				if(this.usermove == 1) {
					$(".PlanningSemaine" + (index) + " .creneauMission").dotdotdot(this.dodotdotConfiguration);
					console.log('dotdotdot sur ' + index);
				}
				else {
					$(".PlanningSemaine" + (index - 2) + " .creneauMission").dotdotdot(this.dodotdotConfiguration);
					console.log('dotdotdot sur ' + (index - 2));
				}
			}

			//in this case the planning has already been commited
			if (this.usermove == 1 || this.usermove == -1) {
				this.usermove = 0;
				this.SlideToCommit = index;
			}
			//in this case, planning should be comited
			else {
				this.openPopup(); //// WHAT?
			}
		},
		validate : function(source) {
			$.mobile.showPageLoadingMsg();
			var thisObject = this;
			// set to true if the user has tapped on the previous/next buttons
			var planningShouldMove = this.usermove == 1 || this.usermove == -1;
			this.model.commitWeek(this.SlideToCommit - 1,
					function(data){
						if (thisObject.usermove == -1) {
							thisObject.swipePreviousWeek();
						}
						else if (thisObject.usermove == 1) {
							thisObject.swipeNextWeek();
						}
						thisObject.usermove = 0;
						MyApp.openPopup('#dialog','Envoi du planning réussi');
					},function(data,errorMessage){
						MyApp.openPopup('#Errordialog',errorMessage.LibelleErreur);
					},function(data){
						$.mobile.hidePageLoadingMsg();
						if (thisObject.usermove == -1) {
							thisObject.swipePreviousWeek();
						}
						else if (thisObject.usermove == 1) {
							thisObject.swipeNextWeek();
						}
						thisObject.usermove = 0;
					}
			);

			if(planningShouldMove) {
				if(this.usermove == 1) {
					this.swipe.next();
				}
				else if(this.usermove == -1){
					this.swipe.prev();
				}
			}
		},
		// loads the previous week in the model
		loadPreviousWeek : function (annee, semaine) {
			this.indexNumber = 1;
			var weekDate = this.getMomentDateFromISO(annee, semaine, 1);
			weekDate.subtract(1, 'week');
			this.loadWeek(weekDate.isoWeekYear(), weekDate.isoWeek());
		},
		// loads the next week in the model
		loadNextWeek : function (annee, semaine) {
			this.indexNumber = this.swipe.getNumSlides() - 1;
			var weekDate = this.getMomentDateFromISO(annee, semaine, 1);
			weekDate.add(1, 'week');
			this.loadWeek(weekDate.isoWeekYear(), weekDate.isoWeek());
		},
		// loads a new week in the model
		loadWeek : function (annee, semaine) {
			$.mobile.loading( 'show', {
				text: 'Chargement du planning',
				textonly: true,
				textVisible: true,
				theme: 'b',
				html: ""
			});
			this.model.initialise(annee, semaine);
		},
		goPreviousWeek : function(source) {
			// storing the gesture wanted by the user before getting the pop-up
			this.usermove = -1;
			this.openPopup();
		},
		goNextWeek : function(source) {
			// storing the gesture wanted by the user before getting the pop-up
			this.usermove = 1;
			this.openPopup();
		},
		openPopup : function() {
			if (this.doNotCommit != true){
				if (MyApp.oSessionManager.getPlanningAutocommit(MyApp.oSessionManager.getLogin()) || !this.model.isPlanningWeekModified(this.model.attributes.Plannings[this.SlideToCommit - 1])){
					this.validate();
				}
				else {
					$('body').css('overflow', 'hidden');
					$('#SendPlanningdialog').popup('open');
				}
			}
			else {
				this.doNotCommit = false;
			}

		},
		planningPopupOK : function() {
			if ($('#planningAutoCommit')[0].checked) {
				MyApp.oSessionManager.setPlanningAutocommit(MyApp.oSessionManager.getLogin(), 'true')
			}
			$('body').css('overflow', 'auto');
			$('#SendPlanningdialog').popup('close');
			this.validate();
		},
		planningPopupCancel : function() {
			$('body').css('overflow', 'auto');
			$('#SendPlanningdialog').popup('close');
			// we should
			if (this.usermove != 1 && this.usermove != -1){
				// set a variable in order not to trigger the event that commit the week
				this.doNotCommit = true;
				this.swipe.slide(this.SlideToCommit);
			}
		},
		swipePreviousWeek : function() {
			this.swipe.prev();
		},
		swipeNextWeek : function() {
			this.swipe.next();
		},
		// closes all error dialogs
		closeErrorPopup : function() {
			$('body').css('overflow', 'auto');
			$('#Errordialog').popup('close');
		},
		changeCellState : function(source){
			console.log('state should be changed');
			var cellArgs = source.currentTarget.id.split('_');
			var cellule = this.model.attributes.Plannings[cellArgs[1]].Planning[cellArgs[2]][cellArgs[3]];
			switch (cellule.Statut) {
				case 'nonRenseigne': cellule.Statut = 'dispo';
									cellule.Modifie = true;
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).removeClass('PlanningCellToBeFilled');
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).addClass('PlanningCellAvailable');
									$('#divLabel_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).text('Dispo');break;
				case 'dispo':cellule.Statut = 'indispo';
									cellule.Modifie = true;
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).removeClass('PlanningCellAvailable');
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).addClass('PlanningCellUnavailable');
									$('#divLabel_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).text('Indispo');break;
				case 'indispo': cellule.Statut = 'dispo';
									cellule.Modifie = true;
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).removeClass('PlanningCellUnavailable');
									$('#Cell_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).addClass('PlanningCellAvailable');
									$('#divLabel_' + cellArgs[1] + '_' + cellArgs[2] + '_' + cellArgs[3]).text('Dispo');break;
				case 'mission': this.goToMission(cellule.IdMission);break;
        default:

          console.log("bien entendu un switch sans default, ça fait tache....", source);
          break;
			}
		},
		// Redirect to the page of the mission
		goToMission : function(idMission){
			var cachedValue = MyApp.oSessionManager.getCacheValue('details_'+idMission);
			if(cachedValue){
				$.mobile.showPageLoadingMsg("b");
				if (cachedValue.Statut == 'en cours'){
					window.location.hash = '#enCoursSynthese/' + idMission;
				}
				else {
					window.location.hash = '#propositionDetails/' + idMission;
				}
			}
			else {
				var backboneObject = Backbone;
				var appObject = MyApp;
				pamHelper.sendRestRequest({
					url: 'Mission/' + idMission+'/Details',
					success: function (data) {
						if (data.DateDebut != undefined) {
							datehHelper = new DateHelper();
							data.DateDebut = datehHelper.parseDate(data.DateDebut);
							data.DebutString = datehHelper.formatDate(data.DateDebut);
						}
						appObject.oSessionManager.setCacheValue('details_'+data.Id,JSON.stringify(data));
						if (data.Statut == 'en cours'){
							window.location.hash = '#enCoursSynthese/' + data.Id;
						}
						else {
							window.location.hash = '#propositionDetails/' + data.Id;
						}
					},
					error : function (data, errorMessage){

						$('#ErrorMissionText').text(errorMessage.LibelleErreur);
						$('body').css('overflow', 'hidden');
						$('#ErrorMissiondialog').popup('open');

					}
				});
			}
		},
		checkIfNotUnsavedChanges : function(event){
			if(this.model.isPlanningModified(this.SlideToCommit - 1)){
				this.currentFooterTarget = $(event.target).closest(".FooterLink").attr('href');
				event.preventDefault();
				$('body').css('overflow', 'hidden');
				$('#NonSavedChangesdialog').popup('open');
			}
		},
		checkIfNotUnsavedChangesActivation : function(event){
			if(this.model.isPlanningModified(this.SlideToCommit - 1)){
				event.stopImmediatePropagation();
			}
		},
		NotCommitedDialogOKHandler : function(){
			window.location.hash = this.currentFooterTarget;
			$('body').css('overflow', 'auto');
			$('#NonSavedChangesdialog').popup('close');
		},
		NotCommitedDialogCancelHandler : function(){
			$('body').css('overflow', 'auto');
			$('#NonSavedChangesdialog').popup('close');
		},
		ErrorMissiondialogOKHandler : function(){
			$('body').css('overflow', 'auto');
			$('#ErrorMissiondialog').popup('close');
		},
		/**
		 * returns a momenjs date instace from the ISO year and ISO week
		 * year, number : ISO year of the date
		 * week, number : ISO week of the date
		 * day, number : number of the day in the week (sunday is 0)
		 */
		getMomentDateFromISO : function(year, week, day){
			if(week < 10){
				week = '0' + week;
			}
			return moment(year + '-W' + week + '-' + day);
		}
	});

	return view;
});
