define(['jquery', 'underscore', 'backbone', 'pamhelper','generic' , 'text!templates/propositionDetails.html', 'text!templates/commons/headerSmall.html', 'text!templates/commons/footer.html',
        'js/models/DetailedPropositionModel.js', 'text!templates/auth/auth_dialog.html', 'text!templates/propositionRefus/confirm.html'], 
        function($, _, Backbone, pamHelper, GenericView, tmpProposistionDetails, tmpHeaderSmall, tmpFooter, DetailedPropositionModel,tmpDialog,tmpRefusDialog) {
	var view = GenericView.extend({
		//transition: 'none',

		name:'propositionDetails',
		events: {
			"click #AcceptMissionButton" : "acceptMission",
			"click #RefuseMissionButton" : "sendRefusAutreMessage"
		},
		initialize : function() {
			console.log("Initialisation Vue ".concat(this.name));
			this.events = _.extend({}, this.genericEvents, this.events);
			this.delegateEvents();
			$.mobile.showPageLoadingMsg("b");
			_.bindAll(this, 'render');
			_.bindAll(this, 'renderData');
			this.model = new DetailedPropositionModel;
			this.model.bind('change', this.renderData);
			this.model.initialise({id : this.options.idMission});
			console.log("Sortie Initialisation Vue ".concat(this.name));
		},
		render : function() {
			console.log("Rendu Vue ".concat(this.name));
			// Si le nom de service n'est pas renseigné
			// On affichera le nom de l'entreprise dans l'acceptation partielle
			if(this.model.get('Service') == null || this.model.get('Service') == undefined || this.model.get('Service') == ""){
				var tableauDescriptif =  this.model.get('Descriptif');
				var entreprise = "";
				for(var i=0; i<tableauDescriptif.length; i++){
					if(tableauDescriptif[i].Libelle == "Entreprise"){
						entreprise = tableauDescriptif[i].Contenu;
					}
				}
				MyApp.oSessionManager.setCurrentMissionEntreprise(entreprise);
				MyApp.oSessionManager.setCurrentMissionSevice(null);
			}else{
				MyApp.oSessionManager.setCurrentMissionSevice(this.model.get('Service'));
				MyApp.oSessionManager.setCurrentMissionEntreprise(null);
			}
			
			$(this.el).append(_.template(tmpProposistionDetails, { offer: this.model, smallHeaderTemplate: _.template(tmpHeaderSmall), footerTemplate: _.template(tmpFooter), authDialog : _.template(tmpDialog), refusDialog : _.template(tmpRefusDialog)  }));
			$.mobile.hidePageLoadingMsg();			
			
			pamHelper.showNbUnreadMissionsBadge(this.el);
			console.log("Sortie Rendu Vue ".concat(this.name));
			
			return this.el;
		},
		dotdotdot : function(){
			if($(".MissionsEnCoursItemDescription")) {$(".MissionsEnCoursItemDescription").dotdotdot();}
		},
		closePopup : function (){
			var path = window.location.pathname;
			window.history.replaceState({} , 'foo', path+"#propositionDetails");
			$('#dialog').popup('close');
		},
		notYet: function(){
			MyApp.openPopup('#dialog',MyApp.oLocale.common.error.notYet);
		},
		acceptMission : function() {
			this.model.accepter();
			MyApp.oSessionManager.clearCacheValue("mission");
			MyApp.oSessionManager.clearCacheValue("details_"+ this.model.get('Id'));
		},
		sendRefusAutreMessage : function() {
			this.motif = 'autreRaison';
			this.openConfirmationRefuse();
		},
		sendRefusMessage : function() {
			this.model.refuser(this.motif);
		},
		refusAndClosePopup: function(){
			this.sendRefusMessage();
			this.closeRefusPopup();
		}
			
	});

	return view;
});
