define(['jquery', 'underscore', 'backbone', 'pamhelper','generic' ,'dotdotdot',
        'text!templates/propositions.html', 'text!templates/commons/header.html', 'text!templates/commons/footer.html',
        'views/propositions/propositionsList', 'text!templates/auth/auth_dialog.html', 'text!templates/auth/auth_dialog.html'],
        function($, _, Backbone, pamHelper, GenericView,dotdotdot, tmpPropositions, tmpHeader, tmpFooter, propositionsListView,tmpDialog) {
	var view = GenericView.extend({
		transition: 'fade',
		error: undefined,
		name:'propositions',
		events: {
		},
		initialize : function(options) {
			console.log("Initialisation Vue ".concat(this.name));
			 	this.events = _.extend({}, this.genericEvents, this.events);
			    this.delegateEvents();
			    $.mobile.showPageLoadingMsg("b");
				this.propositionsListView = new propositionsListView();
				if (options){
					error= options.message;
				}
			console.log("Sortie Initialisation Vue ".concat(this.name));
		},
		render : function() {
			var me = this;
			console.log("Rendu Vue ".concat(this.name));
			//Adding underscore compliant templates for footer and header
			$(me.el).append(_.template(tmpPropositions, { headerTemplate: _.template(tmpHeader), authDialog : _.template(tmpDialog), footerTemplate: _.template(tmpFooter), _: _}));
			
			MyApp.oMissionManager.getMissions(function(missions) {
				var suggestedMissions = missions.GetSuggestedOffers();
				if(suggestedMissions.length == 0){
					$(me.el).find("#missionsListView").html(MyApp.oLocale.mission.error.noPropositionMission);
					$(me.el).find("#missionsListView").removeClass('PropositionsContainer');
				} else {
					$(me.el).find("#missionsListView").addClass('PropositionsContainer');
					pamHelper.assign(me, {
						'#missionsListView' : me.propositionsListView
					});
				}

				pamHelper.showNbUnreadMissionsBadge(me.el, missions.GetCurrentUnreadOffersTag());
			},function(data,errorMessage) {
				$(me.el).find("#missionsListView").html(MyApp.oLocale.mission.error.server);
				$(me.el).find("#missionsListView").removeClass('PropositionsContainer');
			});
			

			var myAppObject = MyApp;
			$(me.el).live('pageshow',function(event, ui){
				
				if($(".PropositionItemTitle")) {$(".PropositionItemTitle").dotdotdot({wrap:'letter'});}
				if($(".PropositionItemTitle")) {$(".PropositionsContainer").dotdotdot();}
				
				if(myAppObject.oSessionManager.getErrorMessageToDisplay() != undefined){
					myAppObject.openPopup("#dialog",myAppObject.oSessionManager.getErrorMessageToDisplay());
				}
			});
			
			$.mobile.hidePageLoadingMsg();			
			console.log("Sortie Rendu Vue ".concat(this.name));
			
			return this;
		},
		closePopup : function (){
			MyApp.oSessionManager.clearErrorMessageToDisplay();
			var path = window.location.pathname;
			window.history.replaceState({} , 'foo', path+"#propositions");
			$('#dialog').popup('close');
		}
	});
	
	return view;
});
