define(['jquery', 'underscore', 'backbone', 'pamhelper','dotdotdot' ,
        'text!templates/propositions/propositionsList.html',
        'collections/OffersCollection'],
        function($, _, Backbone, pamHelper,dotdotdot, tmpPropositionsList, OffersCollection) {
	var view = Backbone.View.extend({
		//transition: 'none',
		events: {
			"click .PropositionItem" : "goToDetails"
		},
		name:'propositionsList',
		initialize : function() {
			console.log("Initialisation Vue ".concat(this.name));
			var me = this;
			_.bindAll(this, 'render');
			console.log("Sortie Initialisation Vue ".concat(this.name));
		},
		render : function() {
			console.log("Rendu Vue ".concat(this.name));
			var me = this;
			//Adding underscore compliant templates for footer and header
			MyApp.oMissionManager.getMissions(function(missions){
				var suggestedMissions = missions.GetSuggestedOffers();
				me.$el.html(_.template(tmpPropositionsList,	{ OffersCollection: missions.GetSuggestedOffers(), _: _}));
	
				if($(".PropositionItemTitle")) { $(".PropositionItemTitle").dotdotdot(); }
				if($(".PropositionItemDescription")) { $(".PropositionItemDescription").dotdotdot(); }

				$.mobile.hidePageLoadingMsg();

			});

			console.log("Sortie Rendu Vue ".concat(this.name));
			
			return this.el;
			
		},
		afterRender: function(){
			
		},
		goToDetails : function(source) {
			Backbone.history.navigate('/propositionDetails/' + source.currentTarget.id.substr(15), true);
		}
	}); 

	return view;
});
