define(['jquery', 'underscore', 'backbone', 'pamhelper', 'md5', 'text!templates/secretQuestion.html', 'text!templates/commons/header.html', 'text!templates/commons/footer.html', 'text!templates/auth/auth_dialog.html'],
    function ($, _, Backbone, pamHelper, MD5, tmpSecretQuestion, tmpHeader, tmpFooter, tmpDialog) {
    var view = Backbone.View.extend({
        transition: 'fade',
        name:'secretquestion',
        events: {
            "click #HeaderReturnButton": "goBack",
            "click #confirmAnswer": "confirmAnswer",
            "click #closebtn": "closePopup",
            "click #ErrorClosebtn": "closePopupError",
        },
        decode: function (error) {
            return error.replace('%20', ' ').replace('%C3%A9', 'é').replace('%C3%8A', 'Ê');
        },
        initialize: function (options) {
            _.bindAll(this, 'nextPage');
            _.bindAll(this, 'render');
            //mode is 'check' or 'select' => we look for either check user answer to his previously set question, or look for him to set this question.
            this.redirectToLogin = false;
            if (options.mode) {
                this.render();
                this.email = options.email;
                this.mode = options.mode;

                switch(this.mode)
                {
                    case "select":
                        $('#HeaderReturnButton').css('display', 'none');
                        var msg = '<div id="messageInformatif">S&eacute;lectionnez une question secr&egrave;te.</div>';
                        $('div[data-role="footer"]:first').remove();
                        break;
                    case "checkchangepwd":
                        $('#HeaderReturnButton').css('display', 'none');

                        this.email = options.email;
                        this.mode = options.mode;
                        this.oldpwd = options.oldpwd;
                        this.newpwd = options.newpwd;
                        this.newlogin = options.newlogin;
                        var msg = '<div id="messageInformatif">R&eacute;pondez correctement à la bonne question secr&egrave;te pour changer votre mot de passe.</div>';
                        break;
                    case "check":
                        var msg = '<div id="messageInformatif">R&eacute;pondez correctement à la bonne question secr&egrave;te pour recevoir un Email avec votre mot de passe.</div>';
                        $('div[data-role="footer"]:first').remove();
                        break;
                    case "checkchangelogin":
                        $('#HeaderReturnButton').css('display', 'none');
                        this.email = options.email;
                        this.mode = options.mode;
                        this.newlogin = options.newlogin;
                        var msg = '<div id="messageInformatif">R&eacute;pondez correctement à la bonne question secr&egrave;te pour changer votre Email.</div>';
                        break;
                }

                $('div[data-role="content"]:first').prepend(msg);
            }
            else {
                //ERROR
            }


            //AJAX : get question list !!!! => no preselection, nothing
            this.requestQuestions();
            console.log("Sortie Initialisation Vue ".concat(this.name));
        },
        showMessage: function () {
            if (MyApp.oSessionManager.getErrorMessageToDisplay() != undefined) {
                MyApp.openPopup("#Errordialog", MyApp.oSessionManager.getErrorMessageToDisplay());
                MyApp.oSessionManager.clearErrorMessageToDisplay();
            }
            if (this.message != undefined) {
                if (this.message == MyApp.oLocale.auth.disconnected || this.message == MyApp.oLocale.common.error.serverError) {
                    this.openPopup('#Errordialog', this.message);
                }
                else {
                    this.setErrorLine(this.message);
                }
            }
        },
        goBack: function () {
            window.history.back();
        },
        render: function () {
            console.log("Rendu Vue ".concat(this.name));
            $.mobile.hidePageLoadingMsg();
            $(this.el).append(_.template(tmpSecretQuestion, { headerTemplate: _.template(tmpHeader), footerTemplate: _.template(tmpFooter), authDialog: _.template(tmpDialog) }));
            $('body').append($(this.el));
            $.mobile.changePage($(this.el), {
                changeHash: false,
                transition: 'none'
            });
            console.log("Sortie Rendu Vue ".concat(this.name));
            return this.el;

        },
        requestQuestions: function () {
            //Ajax call to get Questions
            var myAppObject = MyApp;
            var authRequest = { Identifiant: this.email, MotDePasse: "", DeviceID: MyApp.oSessionManager.getDeviceToken(), DeviceName: MyApp.oConfig.deviceName(), VersionAppli: MyApp.oConfig.appVersion(), CodeMarque: MyApp.oConfig.marque(), DeviceFamily: MyApp.oConfig.deviceFamily() };
            pamHelper.sendRestRequest({
                url: '/authpam/Authentification/GetSecretQuestions',
                type: 'POST',
                data: JSON.stringify(authRequest),
                success: function (data) {
                    $('#selectContainer').append('<label for="secretQuestion-box" class="select ui-select AuthLabel">Question secr&egrave;te</label>')
                    $('#selectContainer').append('<select name="secretQuestion-box" id="secretQuestion" ></select>');
                    if (data.Questions) {
                        //Generate options in select box
                        for (var i = 0; i < data.Questions.length; i++) {
                            var htmlItem = "<option value='" + data.Questions[i].Id + "'> " + data.Questions[i].Lien + "</option>";
                            $('#secretQuestion').append(htmlItem);
                        }
                    }

                    $('#secretQuestion').selectmenu();
                }
            });

        },
        confirmAnswer: function () {
            var mail = this.email;

            var self = this;
            var myAppObject = MyApp;
            var question = $('#secretQuestion').val();
            console.log(question);
            var reponse = $('#questionAnswer').val();


            switch (this.mode) {
                case "check":

                    var typeAction = "OUBLI_MP";

                    //Check answer to a previously selected question
                    pamHelper.sendRestRequest({
                        url: 'authpam/Authentification/AccountActions',
                        type: 'POST',
                        data: JSON.stringify({ UserEmail: mail, QuestionId: question, Answer: reponse, OldValue: "", NewValue: "", ActionType: typeAction, BrandCode: MyApp.oConfig.marque() }),
                        success: function (data) {
                            if (data.LibelleRetour == "") {
                                self.openPopup('#Errordialog', myAppObject.oLocale.pwdForgotten.success);
                                self.redirectToLogin = true;
                            }

                        }
                    });

                    break;
                case "select":
                    //Select a question / answer couple to set for account
                    pamHelper.sendRestRequest({
                        url: 'authpam/Authentification/SetSecretQuestion',
                        type: 'POST',
                        data: JSON.stringify({ UserEmail: mail, QuestionId: question, Answer: reponse, OldValue: "", NewValue: "", ActionType: "OUBLI_MP", BrandCode: MyApp.oConfig.marque() }),
                        success: function (data) {
                            self.nextPage();
                        }
                    });

                    console.log('select mode activated');
                    break;
                case "checkchangelogin":
                    pamHelper.sendRestRequest({
                        url: 'authpam/Authentification/AccountActions',
                        type: 'POST',
                        data: JSON.stringify({ UserEmail: mail, QuestionId: question, Answer: reponse, OldValue: this.email, NewValue: this.newlogin, ActionType: "CHANGEMENT_LOGIN", BrandCode: MyApp.oConfig.marque() }),
                        success: function (data) {
                            self.openPopup('#Errordialog', myAppObject.oLocale.secretquestion.successchangelogin);
                        },
                        error: function (data,errorMessage) {
                            self.openPopup('#Errordialog', myAppObject.oLocale.secretquestion.error);
                        }
                    });
                    break;

                case "checkchangepwd":
                    pamHelper.sendRestRequest({
                        url: 'authpam/Authentification/AccountActions',
                        type: 'POST',
                        data: JSON.stringify({ UserEmail: mail, QuestionId: question, Answer: reponse, OldValue: this.oldpwd, NewValue: this.newpwd, ActionType: "CHANGEMENT_MP", BrandCode: MyApp.oConfig.marque() }),
                        success: function (data) {
                            self.openPopup('#Errordialog', myAppObject.oLocale.secretquestion.successchangepwd);
                        },
                        error: function (data,errorMessage) {
                            self.openPopup('#Errordialog', myAppObject.oLocale.secretquestion.error);
                        }
                    });
                    break;
            }
        },
        updateUIBadField: function (fieldId) {
            //$('#'+fieldId).addClass('error');
            $('label[for="' + fieldId + '"]').addClass('error');
        },
        setErrorLine: function (text) {
            if (text && text != '') {
                $("#errorLine").text(text);
                $("#errorLine").show();
            }
            else {
                $("#errorLine").text('');
                $("#errorLine").hide();
            }
        },
        openPopup: function (element_id, text) {
            $('body').css('overflow', 'hidden');
            if (text != '') {
                $(element_id + ' div p').text(text);
                $(element_id).popup();
                $(element_id).popup('open');
            }
        },
        closePopup: function () {
            $('body').css('overflow', 'auto');
            $('#dialog').popup('close');
            // $.mobile.showPageLoadingMsg("b");
        },
        closePopupError: function () {
            $('body').css('overflow', 'auto');
            $('#Errordialog').popup('close');
            if(this.redirectToLogin == true)
                Backbone.history.navigate("auth", true);
        },
        nextPage: function (optionnalViewName, param) {
            try {
                if (optionnalViewName && optionnalViewName != "") {
                    var nextPage = optionnalViewName;
                    if (parameters && param != "")
                        Backbone.history.navigate(nextPage + '/' + param, true);
                    else
                        Backbone.history.navigate(nextPage, true);
                }
                else {
                    var nextPage = optionnalViewName || 'enCours';
                    MyApp.oMissionManager.getMissions(function(missions){

                        // switch (missions.length) {
                        //     case 0: nextPage = 'propositions';
                        //         break;
                        //     case 1: nextPage = 'enCoursSynthese/' + missions[0].get('Id');
                        //         break;
                        // }
                        nextPage = 'propositions';
                        Backbone.history.navigate(nextPage, true);
                    },function(data,errorMessage) {
                        Backbone.history.navigate(nextPage+'?error=' + errorMessage.LibelleErreur, true);
                    });
                }

            } catch (e) {
                this.setErrorLine(e);
            }
        }

    });

    return view;
});
